﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

// neu  
using System.IO;
using System.Diagnostics;
using System.Runtime.InteropServices; // run
using System.Reflection;
using Microsoft.Win32;  

using System.Windows.Threading;  // Timer
using System.Threading;
using HtmlWpfRtf.ColorText;
using System.Media;
using HtmlWpfRtf.Common;

// C:\Users\Kraft300\AppData\Local\Mozilla\Firefox\Profiles\ev9fbkg5.default-release\cache2 
// nder [User Profile]\Local Settings\Application Data\Google\Chrome\User Data\Default\Cache 


namespace HtmlWpfRtf {
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, IMiddleware, ISetMainWindows, IDeleteTabExecuted {

        private String dialogname = "MainWindow";

        public MainWindow() {
            InitializeComponent();

        }

        private bool isFullscreen = false;

        private int mainfontsize;
        private int editorfontsize;

        int tabnr = 0;

        String cacheFirefoxDirectory = @"C:\Users\" + System.Environment.UserName + @"\AppData\Roaming\Mozilla";
        String cacheChromeDirectory = @"C:\Users\" + System.Environment.UserName + @"\AppData\Roaming\Google";
        String cacheOperaDirectory = @"C:\Users\" + System.Environment.UserName + @"\AppData\Roaming\Opera Software";
        // C:\Users\Kraft300\AppData\Roaming\Mozilla\Firefox\installs.ini
        private enum BROWSER {
            Firefox,
            Opera,
            Chrome,
            Edge,
            None
        }


        private void Window_Loaded(object sender, RoutedEventArgs e) {
            //j = 1;
            //String text = "include('customer.php');";
            //String pattern = "[ ][A-Za-z0-9_]{1,}\\.[A-Za-z0-9_]{1,}";
            //System.Text.RegularExpressions.MatchCollection coll = System.Text.RegularExpressions.Regex.Matches(text,
            //        pattern, System.Text.RegularExpressions.RegexOptions.IgnoreCase);
            //foreach (System.Text.RegularExpressions.Match match in coll) {
            //    String s = match.ToString();
            //}


            //String p1 = "[$][A-Za-z_][A-Za-z0-9_]{0,}(->)[$]";
            //String p2 = "[ \r\n\t][A-Za-z_][A-Za-z0-9_]{0,}\\.[A-Za-z_][A-Za-z0-9_]{0,}";
            //String p3 = "[$][A-Za-z_][A-Za-z0-9_]{0,}\\.[A-Za-z_][A-Za-z0-9_]{0,}";
            //String p4 = "[ \r\n\t][A-Za-z_][A-Za-z0-9_]{0,}(->)[A-Za-z_][A-Za-z0-9_]{0,}";


            //String[] sentences = {"$std2[\"Math\"] = 1.0;", "abc\r\n\t$this->$errortext", "abc\r\n\t$abc.error", "abc\r\n\tabc->cnr",
            //    " customer.attrib = 33;",  "include('customer.php');",  "abc\r\n\tthis.errortext" };

            //foreach (string s in sentences) {
            //    Console.Write($"{s,24}");

            //    if (System.Text.RegularExpressions.Regex.IsMatch(s, p1, System.Text.RegularExpressions.RegexOptions.IgnoreCase)) {
            //        Console.WriteLine(" $this->$attrib");
            //    }
            //    if (System.Text.RegularExpressions.Regex.IsMatch(s, p2, System.Text.RegularExpressions.RegexOptions.IgnoreCase)) {
            //        Console.WriteLine("  customer.attrib");
            //    }
            //    if (System.Text.RegularExpressions.Regex.IsMatch(s, p3, System.Text.RegularExpressions.RegexOptions.IgnoreCase)) {
            //        Console.WriteLine("  $customer.attrib");
            //    }
            //    if (System.Text.RegularExpressions.Regex.IsMatch(s, p4, System.Text.RegularExpressions.RegexOptions.IgnoreCase)) {
            //        Console.WriteLine("  customer->attrib");
            //    }
            //}

            mainfontsize = 14;
            editorfontsize = 16;

            mnFont14pg.IsChecked = true;
            mnFontEditor16pg.IsChecked = true;

            fileList.init(this, this);

            mnWordWrap.IsChecked = SingVar.WordWrap;

            String[] args = System.Environment.GetCommandLineArgs();
            for (int i = 1; i < args.Length; i++) {
                String file = args[i];
                String sExt = Basis.getFilenameExt(file).ToLower();
                if (sExt.Equals("xhtml") && File.Exists(file)) {
                    break;  // nur der erste gueltige Parameter
                }
            }

            #region commandbinding definition  
            CommandBindings.Add(new CommandBinding(MyCommands.Newfile, NewFileExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Openfile, OpenFileExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Newdirectory, NewdirectoryExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Dos, DosExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.Savefile, SaveExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.SaveAll, SaveAllExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.SaveAsfile, SaveAsExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Undo, UndoExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Redo, RedoExecuted, CheckCanExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.ColormemoDeleteRegistry, ColormemoDeleteRegistryExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Fullscreen, FullscreenTextExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Copy, CopyExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Paste, PasteExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Cut, CutExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Selectall, SelectallExecuted, CheckCanExecuted));
            //CommandBindings.Add(new CommandBinding(MyCommands.DeleteTab, DeleteTabExecuted, CheckCanExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.Find, FindExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.FindAgain, FindAgainExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Replace, ReplaceExecuted, CheckCanExecuted));
            

            CommandBindings.Add(new CommandBinding(MyCommands.NewInstanz, NewInstanzExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Close, CloseExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.FormatText, FormatTextExecuted, CheckCanExecuted));




            CommandBindings.Add(new CommandBinding(MyCommands.Wordwrap, WordwrapExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.StandardProfi, StandardProfiwrapExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Browser, BrowserExecuted));



            CommandBindings.Add(new CommandBinding(MyCommands.Optionen, OptionsExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.ProgInfo, ProgInfoExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Firefox, FirefoxExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Opera, OperaExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.OperaGX, OperaGXExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Chrome, ChromeExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Edge, EdgeExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.IExplorer, IExplorerExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Browser7, Browser7Executed, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Browser8, Browser8Executed, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.StandardBrowser, StandardBrowserExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.CloseRegister, CloseRegisterExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Register2Left, Register2LeftExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Register2Right, Register2RightExecuted, CheckCanExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.DarkModus, DarkModusExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.LightModus, LightModusExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Calc, CalcExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Notepad, NotepadExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Editor2Notepad, Editor2NotepadExecuted, CheckCanExecuted));
            #endregion

            mnBrowser.IsChecked = false;
            fileList.setBrowserVisible(false);

            DispatcherTimer dispatcherTimer = new DispatcherTimer();
            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            // dispatcherTimer.Interval = new TimeSpan(0, 0, 1);  // hour, min, sec, ms
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(1000);

            dispatcherTimer.Start();

            int fs; 
            fs = Basis.ReadRegInt(SingVar.C_REG_ADR, "mainfontsize");
            if (fs > 0)
                setFontsizeRegistry(fs);
            else
                setFontsizeRegistry(mainfontsize);

            fs = Basis.ReadRegInt(SingVar.C_REG_ADR, "fontsizeeditor");
            if (fs > 0)
                setEditorFontsizeRegistry(fs);
            else
                setEditorFontsizeRegistry(editorfontsize);

            setColors();
            Basis.setWindowPositionFromRegistry(this, SingVar.C_REG_ADR, dialogname);

        }  // window_Loaded



        int timertick = 0;
        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            MyTextBox edit;
            timertick++;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                edit.setLineNummer();
                if (timertick >= 30) {
                    edit.getModell().saveTempFile();
                }
            }
            if (timertick >= 30) {
                timertick = 0;
            }
            if (Directory.GetFiles(fileList.getPath(), "*.php", SearchOption.TopDirectoryOnly).Length > 0) {
                if (!mnPHP_JSP_Direct.IsChecked) {
                    mnPHP_JSP_Direct.IsChecked = true;
                    CheckXampp();
                }
            }

            CommandManager.InvalidateRequerySuggested();
        }


        private void clearFontMenues(object sender) {
            mnFont8pg.IsChecked = false;
            mnFont10pg.IsChecked = false;
            mnFont12pg.IsChecked = false;
            mnFont14pg.IsChecked = false;
            mnFont16pg.IsChecked = false;
            mnFont18pg.IsChecked = false;
            mnFont20pg.IsChecked = false;
            mnFont24pg.IsChecked = false;
            mnFont28pg.IsChecked = false;

            mnFont30pg.IsChecked = false;
            mnFont32pg.IsChecked = false;
            mnFont34pg.IsChecked = false;
            mnFont36pg.IsChecked = false;
            mnFont38pg.IsChecked = false;
            mnFont40pg.IsChecked = false;
            mnFont42pg.IsChecked = false;
            mnFont44pg.IsChecked = false;
            mnFont46pg.IsChecked = false;
            mnFont48pg.IsChecked = false;
            mnFont50pg.IsChecked = false;
            mnFont52pg.IsChecked = false;
            mnFont54pg.IsChecked = false;
            mnFont56pg.IsChecked = false;
            mnFont58pg.IsChecked = false;
            MenuItem mnItem = (MenuItem)sender;
            mnItem.IsChecked = true;
        }

        private void clearFontEditorMenues(object sender) {
            mnFontEditor8pg.IsChecked = false;
            mnFontEditor10pg.IsChecked = false;
            mnFontEditor12pg.IsChecked = false;
            mnFontEditor14pg.IsChecked = false;
            mnFontEditor16pg.IsChecked = false;
            mnFontEditor18pg.IsChecked = false;
            mnFontEditor20pg.IsChecked = false;
            mnFontEditor22pg.IsChecked = false;
            mnFontEditor24pg.IsChecked = false;
            mnFontEditor26pg.IsChecked = false;
            mnFontEditor28pg.IsChecked = false;

            mnFontEditor30pg.IsChecked = false;
            mnFontEditor32pg.IsChecked = false;
            mnFontEditor34pg.IsChecked = false;
            mnFontEditor36pg.IsChecked = false;
            mnFontEditor38pg.IsChecked = false;
            mnFontEditor40pg.IsChecked = false;
            mnFontEditor42pg.IsChecked = false;
            mnFontEditor44pg.IsChecked = false;
            mnFontEditor46pg.IsChecked = false;
            mnFontEditor48pg.IsChecked = false;
            mnFontEditor50pg.IsChecked = false;
            mnFontEditor52pg.IsChecked = false;
            mnFontEditor54pg.IsChecked = false;
            mnFontEditor56pg.IsChecked = false;
            mnFontEditor58pg.IsChecked = false;
            MenuItem mnItem = (MenuItem)sender;
            mnItem.IsChecked = true;
        }

        private void setEditorFontsizeRegistry(int fs) {


            if (fs == 8) {
                mnFontEditor8pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor8pg);
                setEditorFontsize(8);
            }
            if (fs == 10) {
                mnFontEditor10pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor10pg);
                setEditorFontsize(10);
            }
            if (fs == 12) {
                mnFontEditor12pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor12pg);
                setEditorFontsize(12);
            }
            if (fs == 14) {
                mnFontEditor14pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor14pg);
                setEditorFontsize(14);
            }
            if (fs == 16) {
                mnFontEditor16pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor16pg);
                setEditorFontsize(16);
            }
            if (fs == 18) {
                mnFontEditor18pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor18pg);
                setEditorFontsize(18);
            }
            if (fs == 20) {
                mnFontEditor20pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor20pg);
                setEditorFontsize(20);
            }
            if (fs == 22) {
                mnFontEditor22pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor22pg);
                setEditorFontsize(22);
            }
            if (fs == 24) {
                mnFontEditor24pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor24pg);
                setEditorFontsize(24);
            }
            if (fs == 26) {
                mnFontEditor26pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor26pg);
                setEditorFontsize(26);
            }
            if (fs == 28) {
                mnFontEditor28pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor28pg);
                setEditorFontsize(28);
            }
            if (fs == 30) {
                mnFontEditor30pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor30pg);
                setEditorFontsize(30);
            }
            if (fs == 32) {
                mnFontEditor32pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor32pg);
                setEditorFontsize(32);
            }
            if (fs == 34) {
                mnFontEditor34pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor34pg);
                setEditorFontsize(34);
            }
            if (fs == 36) {
                mnFontEditor36pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor36pg);
                setEditorFontsize(36);
            }
            if (fs == 38) {
                mnFontEditor38pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor38pg);
                setEditorFontsize(38);
            }
            if (fs == 40) {
                mnFontEditor40pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor40pg);
                setEditorFontsize(40);
            }
            if (fs == 42) {
                mnFontEditor42pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor42pg);
                setEditorFontsize(42);
            }
            if (fs == 44) {
                mnFontEditor44pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor44pg);
                setEditorFontsize(44);
            }
            if (fs == 46) {
                mnFontEditor46pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor46pg);
                setEditorFontsize(46);
            }
            if (fs == 48) {
                mnFontEditor48pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor48pg);
                setEditorFontsize(48);
            }
            if (fs == 50) {
                mnFontEditor50pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor50pg);
                setEditorFontsize(50);
            }
            if (fs == 52) {
                mnFontEditor52pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor52pg);
                setEditorFontsize(52);
            }
            if (fs == 54) {
                mnFontEditor54pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor54pg);
                setEditorFontsize(54);
            }
            if (fs == 56) {
                mnFontEditor56pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor56pg);
                setEditorFontsize(56);
            }
            if (fs == 58) {
                mnFontEditor58pg.IsChecked = true;
                clearFontEditorMenues(mnFontEditor58pg);
                setEditorFontsize(58);
            }
        }

        private void setFontsizeRegistry(int fs) {
            if (fs == 8) {
                mnFont8pg.IsChecked = true;
                clearFontMenues(mnFont8pg);
                setFontsize(8);
            }
            if (fs == 10) {
                mnFont10pg.IsChecked = true;
                clearFontMenues(mnFont10pg);
                setFontsize(10);
            }
            if (fs == 12) {
                mnFont12pg.IsChecked = true;
                clearFontMenues(mnFont12pg);
                setFontsize(12);
            }
            if (fs == 14) {
                mnFont14pg.IsChecked = true;
                clearFontMenues(mnFont14pg);
                setFontsize(14);
            }
            if (fs == 16) {
                mnFont16pg.IsChecked = true;
                clearFontMenues(mnFont16pg);
                setFontsize(16);
            }
            if (fs == 18) {
                mnFont18pg.IsChecked = true;
                clearFontMenues(mnFont18pg);
                setFontsize(18);
            }
            if (fs == 20) {
                mnFont20pg.IsChecked = true;
                clearFontMenues(mnFont20pg);
                setFontsize(20);
            }
            if (fs == 22) {
                mnFont22pg.IsChecked = true;
                clearFontMenues(mnFont22pg);
                setFontsize(22);
            }
            if (fs == 24) {
                mnFont24pg.IsChecked = true;
                clearFontMenues(mnFont24pg);
                setFontsize(24);
            }
            if (fs == 26) {
                mnFont26pg.IsChecked = true;
                clearFontMenues(mnFont26pg);
                setFontsize(26);
            }
            if (fs == 28) {
                mnFont28pg.IsChecked = true;
                clearFontMenues(mnFont28pg);
                setFontsize(28);
            }
            if (fs == 30) {
                mnFont30pg.IsChecked = true;
                clearFontMenues(mnFont30pg);
                setFontsize(30);
            }
            if (fs == 32) {
                mnFont32pg.IsChecked = true;
                clearFontMenues(mnFont32pg);
                setFontsize(32);
            }
            if (fs == 34) {
                mnFont34pg.IsChecked = true;
                clearFontMenues(mnFont34pg);
                setFontsize(34);
            }
            if (fs == 36) {
                mnFont36pg.IsChecked = true;
                clearFontMenues(mnFont36pg);
                setFontsize(36);
            }
            if (fs == 38) {
                mnFont38pg.IsChecked = true;
                clearFontMenues(mnFont38pg);
                setFontsize(38);
            }
            if (fs == 40) {
                mnFont40pg.IsChecked = true;
                clearFontMenues(mnFont40pg);
                setFontsize(40);
            }
            if (fs == 42) {
                mnFont42pg.IsChecked = true;
                clearFontMenues(mnFont42pg);
                setFontsize(42);
            }
            if (fs == 44) {
                mnFont44pg.IsChecked = true;
                clearFontMenues(mnFont44pg);
                setFontsize(44);
            }
            if (fs == 46) {
                mnFont46pg.IsChecked = true;
                clearFontMenues(mnFont46pg);
                setFontsize(46);
            }
            if (fs == 48) {
                mnFont48pg.IsChecked = true;
                clearFontMenues(mnFont48pg);
                setFontsize(48);
            }
            if (fs == 50) {
                mnFont50pg.IsChecked = true;
                clearFontMenues(mnFont50pg);
                setFontsize(50);
            }
            if (fs == 52) {
                mnFont52pg.IsChecked = true;
                clearFontMenues(mnFont42pg);
                setFontsize(52);
            }
            if (fs == 54) {
                mnFont54pg.IsChecked = true;
                clearFontMenues(mnFont44pg);
                setFontsize(54);
            }
            if (fs == 56) {
                mnFont56pg.IsChecked = true;
                clearFontMenues(mnFont46pg);
                setFontsize(56);
            }
            if (fs == 58) {
                mnFont58pg.IsChecked = true;
                clearFontMenues(mnFont48pg);
                setFontsize(58);
            }
        }

        private void mnFont_Click(object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem)sender;
            clearFontMenues(sender);
            setFontsize(Convert.ToInt32(mn.Tag));
        }
        private void mnFontEditor_Click(object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem)sender;
            clearFontEditorMenues(sender);
            setEditorFontsize(Convert.ToInt32(mn.Tag));

        }

        private void setEditorFontsize(int size) {
            this.editorfontsize = size;
            Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsizeeditor", size);
            MyTextBox edit;
            foreach (MyTabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                edit.setFontsize(size);
                tabpage.setFontsize(size);
            }
        }


        private void setFontsize(int size) {
            this.mainfontsize = size;
            Basis.WriteRegInt(SingVar.C_REG_ADR, "mainfontsize", size);
            if (fileList != null) {
                fileList.setFontsize(size);
            }
            toolbar1.FontSize = size;
            mainMenu.FontSize = size;
        }




        private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = tabcontrol.Items.Count > 0;
        }

        private bool isLoadedinTabControl(string sFilename, bool showtab = false) {
            MyTextBox edit;
            int i = 0;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                if (edit.getModell().Filename.Equals(sFilename, StringComparison.CurrentCultureIgnoreCase)) {
                    if (showtab) {
                        tabcontrol.SelectedIndex = i;
                    }
                    return true;
                }
                i++;
            }
            return false;
        }

        // Schnittstelle
        public void insertFile(String htmlFilename) {
            int index = -1;
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Shift)) {
                tabcontrol.Items.Clear();
            }

            if (!isLoadedinTabControl(htmlFilename, true)) {
                String fn = htmlFilename.ToLower();
                if ( fn.EndsWith(".xhtml") || fn.EndsWith(".html") || fn.EndsWith(".htm") || fn.EndsWith(".php") || fn.EndsWith(".jsp") || fn.EndsWith(".js")) {
                    insertFile2TabControl(htmlFilename, "", MyTextBox.TextBoxTyp.HTML);
                }
                else if (fn.EndsWith(".css") ) {
                    insertFile2TabControl(htmlFilename, "", MyTextBox.TextBoxTyp.CSS);
                }
                else {
                    Basis.Message("Fehlerhafte Abfrage in load2Tab\r\n" + htmlFilename, "Fehler");
                    insertFile2TabControl(htmlFilename, "", MyTextBox.TextBoxTyp.HTML);
                }
                index = tabcontrol.Items.Count;
            }


            String xhtml = Basis.getFilenameExt(htmlFilename).ToLower();
            if (xhtml.Equals("xhtml")) {
                String filenameCSS = Basis.changeFilenameExt(htmlFilename, "css");
                if (File.Exists(filenameCSS)) {
                    if (!isLoadedinTabControl(filenameCSS)) {
                        insertFile2TabControl(filenameCSS, htmlFilename, MyTextBox.TextBoxTyp.CSS);
                    }
                }
            }
            else {

            }

            if (xhtml.Equals("html") || xhtml.Equals("htm")) {
                String filenameCSS = Basis.changeFilenameExt(htmlFilename, "css");
                if (File.Exists(filenameCSS)) {
                    if (!isLoadedinTabControl(filenameCSS)) {
                        insertFile2TabControl(filenameCSS, htmlFilename, MyTextBox.TextBoxTyp.CSS);
                    }
                }
            }
            else {

            }

            if (xhtml.Equals("php") || xhtml.Equals("jsp")) {
                String filenameCSS = Basis.changeFilenameExt(htmlFilename, "css");
                if (File.Exists(filenameCSS)) {
                    if (!isLoadedinTabControl(filenameCSS)) {
                        insertFile2TabControl(filenameCSS, htmlFilename, MyTextBox.TextBoxTyp.CSS);
                    }
                }
            }
            else {

            }



            if (index > -1) tabcontrol.SelectedIndex = index - 1;

            String fileext = Basis.getFilenameExt(htmlFilename).ToLower();
            if (fileext.Equals("php") || fileext.Equals("jsp")) {
                mnPHP_JSP_Direct.IsChecked = true;
            }


        }

        public void insertFile2TabControl(String filename, String htmlFilename, MyTextBox.TextBoxTyp editorTyp) {
            MyTabItem tabPage1 = new MyTabItem(this, ++tabnr);
            tabPage1.Title = Basis.getFilename(filename);
            //tabPage1.FontSize = fontsize;
            tabPage1.setFontsize(mainfontsize);

            Modell modell = new Modell(tabPage1);
            if (htmlFilename.Length > 0) modell.Htmlfilename = htmlFilename;
            MyTextBox edit = new MyTextBox(this, 1, editorTyp, modell);
            tabPage1.Content = edit;
            tabcontrol.Items.Add(tabPage1);

            edit.Modified = false;
            //edit.WordWrap = SingVar.WordWrap;
            edit.setFontsize(this.editorfontsize);
             edit.loadFile(filename);

            tabPage1.FontSize = mainfontsize;
            tabPage1.Focus();            
            setEditorFontsize(this.editorfontsize);
        }


        private string SaveNewFile(int filetyp) {
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.InitialDirectory = SingVar.LastPath;
            switch (filetyp) {
                case WNewFile.C_HTMLCSS:
                case WNewFile.C_HTML5:
                    saveFileDialog.Filter = "HTML-Files (*.xhtml)|*.xhtml|" +
                    "HTML-Files (*.html;*.htm)|*.html;*.htm|" +
                    "HTML-Files (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.htm|" +
                    "CSS-Files (*.css)|*.css|" +
                    "XML-Files (*.xml;*.xsl)|*.xml;*.xsl|" +
                    "PHP-Files (*.php)|*.php|jsp files (*.jsp)|*.jsp|" +
                    "All files (*.*)|*.*";
                    saveFileDialog.DefaultExt = "xhtml";
                    break;
                case WNewFile.C_HTML:
                    saveFileDialog.Filter = "HTML-Files (*.html;*.htm)|*.html;*.htm|" +
                    "HTML-Files (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.htm|" +
                    "JSP-Files (*.jsp)|*.jsp|" +
                    "All files (*.*)|*.*";
                    saveFileDialog.DefaultExt = "html";
                    break;

                case WNewFile.C_PHP:
                case WNewFile.C_PHPPUR:
                    saveFileDialog.Filter = "PHP-Files (*.php)|*.php|" +
                        "HTML-Files (*.xhtml)|*.xhtml|" +
                    "HTML-Files (*.html;*.htm)|*.html;*.htm|" +
                    "HTML-Files (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.htm|" +
                    "JSP-Files (*.jsp)|*.jsp|" +
                    "All files (*.*)|*.*";
                    saveFileDialog.DefaultExt = "php";
                    break;
                case WNewFile.C_JSPHTML:
                case WNewFile.C_JSPPUR1:
                    saveFileDialog.Filter = "JSP-Files (*.jsp)|*.jsp|" +
                        "HTML-Files (*.xhtml)|*.xhtml|" +
                    "HTML-Files (*.html;*.htm)|*.html;*.htm|" +
                    "HTML-Files (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.htm|" +
                    "All files (*.*)|*.*";
                    saveFileDialog.DefaultExt = "php";
                    break;
                case WNewFile.C_JAVASCRIPT:
                    saveFileDialog.Filter = "Javascript-Files (*.js)|*.js|" +
                    "All files (*.*)|*.*";
                    saveFileDialog.DefaultExt = "js";
                    break;

                case WNewFile.C_CSS:
                    saveFileDialog.Filter = "CSS-Files (*.css)|*.css|" +
                    "HTML-Files (*.xhtml)|*.xhtml|" +
                    "HTML-Files (*.html;*.htm)|*.html;*.htm|" +
                    "HTML-Files (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.htm|" +
                    "PHP-Files (*.php)|*.php|jsp files (*.jsp)|*.jsp|" +
                    "All files (*.*)|*.*";
                    saveFileDialog.DefaultExt = "css";
                    break;

                default: MessageBox.Show("Fehler in Modul SaveNewFile, Falscher Dateityp");
                    break;
            }

            if (saveFileDialog.ShowDialog(this) == true) {
                String path, filename;
                Basis.splitFilename(saveFileDialog.FileName, out path, out filename);
                return path + filename.Replace("ä", "ae").Replace("ö", "oe").Replace("ü", "ue").Replace("Ä", "Ae").Replace("Ö", "Oe").Replace("Ü", "Ue").Replace("ß", "ss");
            }
            else {
                return "";
            }
        }

        private void DosExecuted(object sender, ExecutedRoutedEventArgs e) {
            fileList.dos();
        }


        private void NewdirectoryExecuted(object sender, ExecutedRoutedEventArgs e) {
            fileList.newFolder();  // MyFileList2
        }


        private void NewFileExecuted(object sender, ExecutedRoutedEventArgs e) {
            WNewFile dialog = new WNewFile(this);
            dialog.ShowDialog();   
            if (dialog.RetCode > 0) {
                int layout = dialog.Layout;
                string filename = SaveNewFile(dialog.RetCode);
                if (filename.Equals("")) return;
                SingVar.LastPath = Basis.getPath(filename);
                fileList.updatePath();
                string cssFilename = Basis.changeFilenameExt(filename, "css");

                switch (dialog.RetCode) {
                    case WNewFile.C_HTMLCSS:
                    case WNewFile.C_HTML5:  
                         
                        if (dialog.RetCode == WNewFile.C_HTMLCSS) {
                            SingVar.SaveCSS_Html_BasicXHTML(filename, cssFilename, layout);
                        }
                        else {
                            SingVar.SaveCSS_Html_HTML5(filename, cssFilename, layout);
                        }
                        insertFile(filename);
                        // insertFile(sFile2);  // automatic
                        break;

                    case WNewFile.C_HTML:
                    case WNewFile.C_PHP:
                        // panel1 = new RegPanel(sFilename, MenueTyp_HTML);
                        SingVar.SavePHP_HTML(filename, cssFilename, layout);
                        insertFile(filename);
                        break;
                    case WNewFile.C_PHPPUR:
                        // panel1 = new RegPanel(sFilename, MenueTyp_HTML);
                        SingVar.SavePHPPUR(filename);
                        insertFile(filename);
                        break;
                    case WNewFile.C_JSPHTML:
                        // panel1 = new RegPanel(sFilename, MenueTyp_HTML);
                        SingVar.SaveJSP_HTML(filename, cssFilename, layout);
                        insertFile(filename);
                        break;
                    case WNewFile.C_JSPPUR1:
                        // panel1 = new RegPanel(sFilename, MenueTyp_HTML);
                        SingVar.SaveJSP_PUR(filename, cssFilename, layout);
                        insertFile(filename);
                        break;
                    case WNewFile.C_JAVASCRIPT:
                        // panel1 = new RegPanel(sFilename, MenueTyp_HTML);
                        SingVar.SaveJAVASCRIPT(filename);
                        insertFile(filename);
                        break;

                    case WNewFile.C_CSS:
                        // panel1 = new RegPanel(sFilename, MenueTyp_CSS);
                        SingVar.SaveCSSHTML5(filename, layout);
                        insertFile(filename);
                        break;

                    default: MessageBox.Show("Fehler in Modul NewClick, Falsche Dateiauswahl");
                        break;
                }
            }

        }  // mnNew_Click



        private void OpenFileExecuted(object sender, ExecutedRoutedEventArgs e) {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "HTML-Files (*.xhtml)|*.xhtml|" +
            "HTML-Files (*.html;*.htm)|*.html;*.htm|" +
            "HTML-Files (*.xhtml;*.html;*.htm)|*.xhtml;*.html;*.htm|" +
            "CSS-Files (*.css)|*.css|XML-Files (*.xml;*.xsl)|*.xml;*.xsl|" +
            "PHP-Files (*.php)|*.php|jsp files (*.jsp)|*.jsp|" +
            "All files (*.*)|*.*";

            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".xhtml";
            openFileDialog1.InitialDirectory = SingVar.LastPath;
            openFileDialog1.Multiselect = true;
            openFileDialog1.RestoreDirectory = true;
            openFileDialog1.Title = "Open file(s)";

            if (openFileDialog1.ShowDialog() == true) {
                if (Keyboard.Modifiers.HasFlag(ModifierKeys.Shift)) {
                    tabcontrol.Items.Clear();
                }

                foreach (String sFilename in openFileDialog1.FileNames) {
                    insertFile(sFilename);
                    SingVar.LastPath = Basis.getPath(sFilename);
                    fileList.updatePath();
                }
            }
        }

        private void SaveAllExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                edit.saveFile();
                edit.createColorText();
            }
        }

        private void SaveExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                Modell modell = edit.getModell();
                if (modell.Filename != null) {
                    edit.saveFile();
                    edit.createColorText();
                }
                else
                    SaveAsExecuted(sender, e);
            }
        }


        private void SaveAsExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            Modell modell = edit.getModell();
            if (Basis.getFilenameExt(modell.Filename).Equals("css")) {
                Basis.Message("Please save the html-file and not the css-file", "Message");
            }
            else {
                SaveFileDialog saveFileDialog1 = new SaveFileDialog();
                saveFileDialog1.Title = "Save as";
                if (edit != null && edit.getModell().Filename.Length > 0) {
                    String path, name, ext;
                    Basis.splitFilename(edit.getModell().Filename, out path, out name, out ext);
                    switch (ext.ToLower()) {
                        case ".htm":
                            saveFileDialog1.Filter = "HTML files (*.htm)|*.htm|All files (*.*)|*.*";
                            saveFileDialog1.DefaultExt = ".htm";
                            break;
                        case ".html":
                            saveFileDialog1.Filter = "HTML files (*.html)|*.html|All files (*.*)|*.*";
                            saveFileDialog1.DefaultExt = ".html";
                            break;
                        case ".xhtml":
                            saveFileDialog1.Filter = "HTML files (*.xhtml)|*.xhtml|All files (*.*)|*.*";
                            saveFileDialog1.DefaultExt = ".xhtml";
                            break;
                        case ".php":
                            saveFileDialog1.Filter = "PHP files (*.php)|*.php|All files (*.*)|*.*";
                            saveFileDialog1.DefaultExt = ".php";
                            break;
                        case ".jsp":
                            saveFileDialog1.Filter = "JSP files (*.jsp)|*.jsp|All files (*.*)|*.*";
                            saveFileDialog1.DefaultExt = ".jsp";
                            break;
                        default:
                            saveFileDialog1.Filter = "All files (*.*)|*.*";
                            saveFileDialog1.DefaultExt = "";
                            break;
                    }
                }
                else {
                    saveFileDialog1.Filter = "HTML files (*.xhtml)|*.xhtml|All files (*.*)|*.*";
                }
                saveFileDialog1.FilterIndex = 1;// zählt von 1 !
                saveFileDialog1.InitialDirectory = SingVar.LastPath;
                if (edit != null && edit.getModell().Filename.Length > 0) {
                    saveFileDialog1.FileName = modell.Filename;

                }
                saveFileDialog1.RestoreDirectory = true;
                if (saveFileDialog1.ShowDialog() == true) {
                    if (edit != null) {
                        String filenameOld = modell.Filename.ToLower();
                        String filenameNew = saveFileDialog1.FileName.ToString();
                        modell.Filename = filenameNew;
                        edit.changeCSSFile(filenameOld, filenameNew); // nicht aktiv
                        edit.createColorText();

                        edit.saveFile();
                        if (filenameOld.EndsWith("html") || filenameOld.EndsWith("htm") ||
                            filenameOld.EndsWith("xhtml") || filenameOld.EndsWith("php") ||
                            filenameOld.EndsWith("jsp")) {
                            String filenameCSSOld = Basis.changeFilenameExt(filenameOld, "css");
                            bool gefunden = false;
                            foreach (MyTabItem tabpage in tabcontrol.Items) {
                                edit = (MyTextBox)tabpage.Content;
                                if (edit.getModell().Filename.ToLower().Equals(filenameCSSOld, StringComparison.CurrentCultureIgnoreCase)) {
                                    // saveAs
                                    modell = edit.getModell();
                                    String filenameCSSNew = Basis.changeFilenameExt(filenameNew, "css");
                                    modell.Filename = filenameCSSNew;
                                    edit.saveFile();
                                    tabpage.Title = Basis.getFilename(filenameCSSNew);
                                    gefunden = true;
                                    break;  
                                }
                            }
                            if (!gefunden && File.Exists(filenameOld)) {
                                File.Copy(filenameOld, filenameNew, true);
                            }
                        }
                        fileList.update();
                    }
                }
            }
        }  // mnSaveAs_Click


        private MyTextBox getActiveEditor() {
            MyTextBox edit;
            if (tabcontrol.Items.Count > 0 && tabcontrol.SelectedIndex >= 0) {
                TabItem tabPage1 = (TabItem)tabcontrol.Items[tabcontrol.SelectedIndex];
                edit = (MyTextBox)tabPage1.Content;
                return edit;
            }
            else {
                return null;
            }
        }





        private void UndoExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.undoClick();
        }
        private void RedoExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.redoClick();

        }




        private void CopyExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                
                edit.Copy();
            }
        }

        private void PasteExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.Paste();
            }
        }
        private void CutExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.Cut();
        }

        private void SelectallExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) edit.SelectAll();
        }


        // suche nun das Register
        public void DeleteTabExecuted(int nr) {
            if (tabcontrol.Items.Count > 0) {
                MyTabItem tabpage;
                for (int i = 0; i < tabcontrol.Items.Count; i++) {
                    tabpage = (MyTabItem)tabcontrol.Items[i];
                    if (tabpage.Nr == nr) {
                        MyTextBox edit = (MyTextBox)tabpage.Content;
                        if (edit.Modified) {
                            MessageBoxResult ret = Basis.readYesNoCancel(
                                "Save the changes?\r\n" + edit.Filename, "Close the register");
                            if (ret == MessageBoxResult.Cancel) return;
                            if (ret == MessageBoxResult.OK) {
                                Modell modell = edit.getModell();
                                if (modell.Filename != null)
                                    edit.saveFile();
                                else
                                    SaveAsExecuted(null, null);
                            }
                            tabcontrol.Items.RemoveAt(i);
                        }
                        else {
                            tabcontrol.Items.RemoveAt(i);
                        }
                    } // if
                } // for
            }// if
        }

        private void FindExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                WFind dialog = new WFind(this);
                dialog.ShowDialog();
                if (dialog.Result) {
                    SingVar.search = dialog.SearchString;
                    SingVar.ignoreCase1 = dialog.IgnoreCase;
                    SingVar.wholeword = dialog.Wholeword;
                    //edit.Search = SingVar.search;
                    edit.searchText(SingVar.search);
                }
            }
        }

        private void FindAgainExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.searchAgain();
            }
        }

        
        private void ReplaceExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                WReplace dialog = new WReplace(this);
                dialog.ShowDialog();
                if (dialog.Result) {
                    SingVar.search = dialog.SearchString;
                    SingVar.ignoreCase1 = dialog.IgnoreCase;
                    SingVar.wholeword = dialog.Wholeword;
                    SingVar.replace = dialog.ReplaceString;
                    //edit.Search = SingVar.search;
                    edit.replaceText(SingVar.search, SingVar.replace, SingVar.ignoreCase1, SingVar.wholeword);
                }
            }
        }


        private void FormatTextExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.format();
            }
        }

        private void ColormemoDeleteRegistryExecuted(object sender, ExecutedRoutedEventArgs e) {
            String title = "FShowColorText";
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Top", 10);
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Left", 10);
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Width", 300);
            Basis.WriteRegInt(SingVar.C_REG_ADR, title + "_Height", 200);
        }

        private void Window_PreviewKeyDown(Object sender, KeyEventArgs e) {
            var alt = e.KeyboardDevice.Modifiers.HasFlag(ModifierKeys.Alt);
            var ctrl = e.KeyboardDevice.Modifiers.HasFlag(ModifierKeys.Control);
            var altGr = alt & ctrl;

            if (Keyboard.IsKeyDown(Key.Escape) && isFullscreen) {
                FullscreenTextExecuted(sender, null);
            }
            if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl))) {
                switch (e.Key) {
                    case Key.C:
                        e.Handled = true;
                        // calc
                        CopyExecuted(null, null);
                        break;


                         

                    case Key.V:
                        e.Handled = true;
                        //PasteExecuted(null, null);  // Strg+V
                        break;
                    case Key.Z:
                        e.Handled = true;
                        //PasteExecuted(null, null);  // Strg+V
                        break;
                    case Key.Y:
                        e.Handled = true;
                        //PasteExecuted(null, null);  // Strg+V
                        break;
                    //        case Key.X:
                    //            e.Handled = true;
                    //            CutExecuted(null, null);
                    //            break;

                    case Key.L:
                        e.Handled = true;
                        Register2LeftExecuted(null, null);
                        break;
                    case Key.R:
                        e.Handled = true;
                        Register2RightExecuted(null, null);
                        break;
                }


            }
        }

        private void Window_KeyUp(Object sender, KeyEventArgs e) {
            var alt = e.KeyboardDevice.Modifiers.HasFlag(ModifierKeys.Alt);
            var ctrl = e.KeyboardDevice.Modifiers.HasFlag(ModifierKeys.Control);
            var altGr = alt & ctrl;
            if (altGr) {
                e.Handled = false;
                return;
            }

            if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl))) {
                switch (e.Key) {
                }


            }
            if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl))  &&
                ((e.KeyboardDevice.IsKeyDown(Key.LeftShift) || e.KeyboardDevice.IsKeyDown(Key.RightShift)) ))   {
                switch (e.Key) {
                    
                    case Key.N:
                        e.Handled = true;
                        NotepadExecuted(null, null);
                        break;

                    case Key.R:
                        e.Handled = true;
                        ReplaceExecuted(null, null);
                        break;

                }
            }
        }


        private void Window_KeyDown(object sender, KeyEventArgs e) {

        }
        private void FullscreenTextExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (isFullscreen) {
                mainMenu.Visibility = Visibility.Visible;
                toolBarTray1.Visibility = Visibility.Visible;
                isFullscreen = false;
                foreach (TabItem tabpage in tabcontrol.Items) {
                    MyTextBox edit = (MyTextBox)tabpage.Content;
                    edit.setMainMenu(Visibility.Visible);
                }
            }
            else {
                mainMenu.Visibility = Visibility.Collapsed;
                toolBarTray1.Visibility = Visibility.Collapsed;
                ColumnDefinitionCollection cols = splitContainer1.ColumnDefinitions;
                if (mnProfi.IsChecked) {
                    GridLength gl1 = new GridLength(0);
                    bnStandard.Content = "Standard";
                    cols[0].Width = gl1;
                    mnProfi.IsChecked = !mnProfi.IsChecked;
                }
                foreach (TabItem tabpage in tabcontrol.Items) {
                    MyTextBox edit = (MyTextBox)tabpage.Content;
                    edit.setMainMenu(Visibility.Collapsed);
                }
                isFullscreen = true; 
            }
            
        }

       

        // setzt den internen Browser
        public void setFile2Browser(String filename) {
            fileList.setFile2Browser(filename);
        }
        public void editorIsModfied() {
            if (SingVar.ColorEditorAktualiserung) {
                MyTextBox edit = getActiveEditor();
            }
        }

        private void tabcontrol_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
        }  


        private void NewInstanzExecuted(object sender, ExecutedRoutedEventArgs e) {
            Process Prog = new Process();
            Prog.StartInfo.FileName =  Basis.getProgPath() + "HtmlWpfRtf.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start();

        }

        private void CloseExecuted(object sender, ExecutedRoutedEventArgs e) {
            Close();  
        }




        private void WordwrapExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit;            
            mnWordWrap.IsChecked = !mnWordWrap.IsChecked;
            SingVar.WordWrap = mnWordWrap.IsChecked;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                //edit.WordWrap = SingVar.WordWrap;
            }
        }

        private void BrowserExecuted(object sender, ExecutedRoutedEventArgs e) {
            // setBrowserVisible
            if (mnBrowser.IsChecked == true) {
                mnBrowser.IsChecked = false;
                fileList.setBrowserVisible(false);
            }
            else {
                mnBrowser.IsChecked = true;
                fileList.setBrowserVisible(true);
            }
        }
        

        private void StandardProfiwrapExecuted(object sender, ExecutedRoutedEventArgs e) {
            ColumnDefinitionCollection cols = splitContainer1.ColumnDefinitions;
            GridLength gl1;
            if (mnProfi.IsChecked) {
                gl1 = new GridLength(0);
                bnStandard.Content = "Standard";
            }
            else {
                gl1 = new GridLength(200);
                bnStandard.Content = "Profi";
            }
            cols[0].Width = gl1;
            mnProfi.IsChecked = !mnProfi.IsChecked;
        }


        private void DarkModusExecuted(object sender, ExecutedRoutedEventArgs e) {
            SingVar.FontcolordialogBackgroundRed = 60;
            SingVar.FontcolordialogBackgroundGreen = 60;
            SingVar.FontcolordialogBackgroundBlue = 60;

            SingVar.LineNumberColordialogForegroundRed = 255;
            SingVar.LineNumberColordialogForegroundGreen = 128;
            SingVar.LineNumberColordialogForegroundBlue = 0;

            SingVar.HtmlColordialogForegroundRed = 255;  // statt blau
            SingVar.HtmlColordialogForegroundGreen = 154;
            SingVar.HtmlColordialogForegroundBlue = 53;

            SingVar.NormalTextColordialogForegroundRed = 255;
            SingVar.NormalTextColordialogForegroundGreen = 255;
            SingVar.NormalTextColordialogForegroundBlue = 255;

            SingVar.SpecialCharactersColordialogForegroundRed = 255;
            SingVar.SpecialCharactersColordialogForegroundGreen = 64;
            SingVar.SpecialCharactersColordialogForegroundBlue = 64;

            SingVar.CommentColordialogForegroundRed = 215;
            SingVar.CommentColordialogForegroundGreen = 215;
            SingVar.CommentColordialogForegroundBlue = 215;

            SingVar.FontcolorRed = SingVar.NormalTextColordialogForegroundRed;
            SingVar.FontcolorGreen = SingVar.NormalTextColordialogForegroundGreen;
            SingVar.FontcolorBlue = SingVar.NormalTextColordialogForegroundBlue;

            SingVar.BGcolorRed = SingVar.FontcolordialogBackgroundRed;
            SingVar.BGcolorGreen = SingVar.FontcolordialogBackgroundGreen;
            SingVar.BGcolorBlue = SingVar.FontcolordialogBackgroundBlue;

            foreach (TabItem tabpage in tabcontrol.Items) {
                MyTextBox edit = (MyTextBox)tabpage.Content;
                //edit.WordWrap = SingVar.WordWrap;
                edit.setColors();
                edit.setFontFamily(new System.Windows.Media.FontFamily(SingVar.Fontfamily));
            }
            setColors();
            bnFirefox.Foreground = Brushes.Red;
            bnOpera.Foreground = Brushes.Yellow;
            bnOperagx.Foreground = Brushes.Red;
            bnChrome.Foreground = Brushes.Yellow;
            bnEdge.Foreground = Brushes.Red;
            bnIExplorer.Foreground = Brushes.Yellow;

        }
        private void LightModusExecuted(object sender, ExecutedRoutedEventArgs e) {

            SingVar.FontcolordialogBackgroundRed = 255;
            SingVar.FontcolordialogBackgroundGreen = 255;
            SingVar.FontcolordialogBackgroundBlue = 255;

            SingVar.LineNumberColordialogForegroundRed = 255;
            SingVar.LineNumberColordialogForegroundGreen = 128;
            SingVar.LineNumberColordialogForegroundBlue = 0;

            SingVar.HtmlColordialogForegroundRed = 05;  // statt blau
            SingVar.HtmlColordialogForegroundGreen = 0;
            SingVar.HtmlColordialogForegroundBlue = 127;

            SingVar.NormalTextColordialogForegroundRed = 0;
            SingVar.NormalTextColordialogForegroundGreen = 0;
            SingVar.NormalTextColordialogForegroundBlue = 0;

            SingVar.SpecialCharactersColordialogForegroundRed = 255;
            SingVar.SpecialCharactersColordialogForegroundGreen = 64;
            SingVar.SpecialCharactersColordialogForegroundBlue = 64;

            SingVar.CommentColordialogForegroundRed = 0;
            SingVar.CommentColordialogForegroundGreen = 127;
            SingVar.CommentColordialogForegroundBlue = 0;

            SingVar.FontcolorRed = SingVar.NormalTextColordialogForegroundRed;
            SingVar.FontcolorGreen = SingVar.NormalTextColordialogForegroundGreen;
            SingVar.FontcolorBlue = SingVar.NormalTextColordialogForegroundBlue;

            SingVar.BGcolorRed = SingVar.FontcolordialogBackgroundRed;
            SingVar.BGcolorGreen = SingVar.FontcolordialogBackgroundGreen;
            SingVar.BGcolorBlue = SingVar.FontcolordialogBackgroundBlue;


            foreach (TabItem tabpage in tabcontrol.Items) {
                MyTextBox edit = (MyTextBox)tabpage.Content;
                //edit.WordWrap = SingVar.WordWrap;
                edit.setColors();
                edit.setFontFamily(new System.Windows.Media.FontFamily(SingVar.Fontfamily));
            }
            setColors();
            bnFirefox.Foreground = Brushes.Red;
            bnOpera.Foreground = Brushes.DarkGreen;
            bnOperagx.Foreground = Brushes.Red;
            bnChrome.Foreground = Brushes.DarkGreen;
            bnEdge.Foreground = Brushes.Red;
            bnIExplorer.Foreground = Brushes.DarkGreen;

        }


        private void OptionsExecuted(object sender, ExecutedRoutedEventArgs e) {
            int tabnr = SingVar.TabNr;
            String tabold = Konst.C_TAB;
            WOptions dialog = new WOptions(this);
            dialog.ShowDialog();
            
            if (dialog.Result) {
                MyTextBox edit;
                if (tabnr != SingVar.TabNr) {                    
                    foreach (TabItem tabpage in tabcontrol.Items) {
                        edit = (MyTextBox)tabpage.Content;
                        edit.replaceTab(tabold,Konst.C_TAB);
                    }
                }
                foreach (TabItem tabpage in tabcontrol.Items) {
                    edit = (MyTextBox)tabpage.Content;
                    //edit.WordWrap = SingVar.WordWrap;
                    edit.setColors();
                    edit.setFontFamily(new System.Windows.Media.FontFamily(SingVar.Fontfamily));
                }
                mnWordWrap.IsChecked = SingVar.WordWrap;
                setColors();

            }
        }  // OptionsExecuted


        void SetMenuItemColor(MenuItem menu) {
            setMenuColor(menu);
            foreach (Object obj in menu.Items) {
                if (obj is MenuItem) {
                    SetMenuItemColor((MenuItem)obj);
                }
            }
        }

        public void setColors() {
            SolidColorBrush fg = Basis.getColor(SingVar.FontcolorRed, SingVar.FontcolorGreen, SingVar.FontcolorBlue);
            SolidColorBrush bg = Basis.getColor(SingVar.BGcolorRed, SingVar.BGcolorGreen, SingVar.BGcolorBlue);
            tabcontrol.Foreground = fg;
            tabcontrol.Background = bg;

            toolbar1.Background = bg;
            mainMenu.Background = bg;

            toolbar1.Foreground = fg;
            mainMenu.Foreground = fg;
            bnStandard.Foreground = fg;
            bnBrowser.Foreground = fg;

            fileList.setColors();
            fileList.Foreground = fg;
            fileList.Background = bg;

            foreach (MenuItem mn in mainMenu.Items) {
                SetMenuItemColor(mn);
            }

        }

        private void setMenuColor(MenuItem mn) {
            SolidColorBrush fg = Basis.getColor(SingVar.FontcolorRed, SingVar.FontcolorGreen, SingVar.FontcolorBlue);
            SolidColorBrush bg = Basis.getColor(SingVar.BGcolorRed, SingVar.BGcolorGreen, SingVar.BGcolorBlue);
            mn.Foreground = fg;
            mn.Background = bg;

        }


        private void ProgInfoExecuted(object sender, ExecutedRoutedEventArgs e) {
            WProgInfo dialog = new WProgInfo(this);
            dialog.ShowDialog();
        }







        public void update(String sFilename) {
            this.Title = "HTML-Editor-2015,2019 (RTF): " + sFilename;
        }



        private String firefoxBrowser = "";
        private void FirefoxExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (firefoxBrowser.Length > 0) {
                execute(BROWSER.Firefox, firefoxBrowser, false);
            }
            else {
                string sBrowser = "";
                FileInfo browserFileInfo = null;
                DirectoryInfo mainDir = null;
                String[] dirs = { "C:\\Program Files (x86)\\Mozilla Firefox\\", "C:\\Program Files\\Mozilla Firefox\\", "C:\\Programme\\Mozilla Firefox\\" };
                foreach (String dir in dirs) {
                    if (Directory.Exists(dir)) {
                        mainDir = new DirectoryInfo(dir);
                        FileInfo[] files = mainDir.GetFiles("firefox.exe", SearchOption.AllDirectories);
                        foreach (FileInfo fi in files) {
                            if (browserFileInfo == null) {
                                browserFileInfo = fi;
                                sBrowser = fi.FullName;
                            }
                            else {
                                if (fi.CreationTime > browserFileInfo.CreationTime) {
                                    browserFileInfo = fi;
                                    sBrowser = fi.FullName;
                                }
                            }
                        }
                    }
                }
                if (sBrowser.Length > 0) {
                    firefoxBrowser = sBrowser;
                    execute(BROWSER.Firefox, sBrowser, false);
                }
            }
        }


        private String operaBrowser = "";
        private void OperaExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (operaBrowser.Length > 0) {
                execute(BROWSER.Opera, operaBrowser, false);
            }
            else {  
                // C: \Users\Kraft300\AppData\Local\Programs\Opera\launcher.exe
                string sBrowser = "";
                FileInfo browserFileInfo = null;
                DirectoryInfo mainDir = null;
                String username = System.Environment.UserName;
                // "C:\Users\Kraft300\AppData\Local\Programs\Opera GX\launcher.exe"
                String[] dirs = {
                   "C:\\Program Files (x86)\\Opera\\",
                   "C:\\Programme\\Opera\\",
                   "C:\\Users\\"+username + "\\AppData\\Local\\Programs\\Opera\\",
                };
                String[] apps = { "opera.exe", "opera.exe", "launcher.exe" };
                for (int i=0; i<dirs.Length; i++) {  
                    if (Directory.Exists(dirs[i])) {
                        mainDir = new DirectoryInfo(dirs[i]);
                        FileInfo[] files = mainDir.GetFiles(apps[i], SearchOption.AllDirectories);
                        foreach (FileInfo fi in files) {
                            if (browserFileInfo == null) {
                                browserFileInfo = fi;
                                sBrowser = fi.FullName;
                            }
                            else {
                                if (fi.CreationTime > browserFileInfo.CreationTime) {
                                    browserFileInfo = fi;
                                    sBrowser = fi.FullName;
                                }
                            }
                        }
                    }
                }
                if (sBrowser.Length > 0) {
                    operaBrowser = sBrowser;
                    execute(BROWSER.Opera, sBrowser, false);
                }
            }
        }


        
        private String operagxBrowser = "";
        private void OperaGXExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (operagxBrowser.Length > 0) {
                execute(BROWSER.Opera, operagxBrowser, false);
            }
            else {
                // C: \Users\Kraft300\AppData\Local\Programs\Opera\launcher.exe
                string sBrowser = "";
                FileInfo browserFileInfo = null;
                DirectoryInfo mainDir = null;
                String username = System.Environment.UserName;
                // "C:\Users\Kraft300\AppData\Local\Programs\Opera GX\launcher.exe"
                String[] dirs = {
                   "C:\\Program Files (x86)\\Opera GX\\",
                   "C:\\Programme\\Opera GX\\",
                   "C:\\Users\\"+username + "\\AppData\\Local\\Programs\\Opera GX\\"
                };
                String[] apps = { "opera.exe", "opera.exe", "launcher.exe", "launcher.exe" };
                for (int i = 0; i < dirs.Length; i++) {
                    if (Directory.Exists(dirs[i])) {
                        mainDir = new DirectoryInfo(dirs[i]);
                        FileInfo[] files = mainDir.GetFiles(apps[i], SearchOption.AllDirectories);
                        foreach (FileInfo fi in files) {
                            if (browserFileInfo == null) {
                                browserFileInfo = fi;
                                sBrowser = fi.FullName;
                            }
                            else {
                                if (fi.CreationTime > browserFileInfo.CreationTime) {
                                    browserFileInfo = fi;
                                    sBrowser = fi.FullName;
                                }
                            }
                        }
                    }
                }
                if (sBrowser.Length > 0) {
                    operagxBrowser = sBrowser;
                    execute(BROWSER.Opera, sBrowser, false);
                }
            }
        }

        private void ChromeExecuted(object sender, ExecutedRoutedEventArgs e) {
            string sBrowser = "chrome.exe";
            execute(BROWSER.Chrome, sBrowser, false);
        }

        private String msedgeBrowser = "";
        private void EdgeExecuted(object sender, ExecutedRoutedEventArgs e) {
            //string sBrowser = "msedge.exe";
            if (msedgeBrowser.Length > 0) {
                execute(BROWSER.Edge, msedgeBrowser, false);
            }
            else {
                // C: \Users\Kraft300\AppData\Local\Programs\Opera\launcher.exe
                string sBrowser = "";
                FileInfo browserFileInfo = null;
                DirectoryInfo mainDir = null;
                String username = System.Environment.UserName;
                String[] dirs = {
                   "C:\\Program Files (x86)\\Microsoft\\Edge\\Application\\",
                   "C:\\Programme\\Microsoft\\Edge\\Application\\",
                   "C:\\Users\\"+username + "\\AppData\\Local\\Programs\\Microsoft\\Edge\\Application\\",
                   "C:\\Users\\"+username + "\\AppData\\Local\\Programs\\Edge\\Application\\",
                   "C:\\Users\\"+username + "\\AppData\\Local\\Programs\\Edge\\",
                };
                String[] apps = { "msedge.exe", "launcher.exe" };
                for (int i = 0; i < dirs.Length; i++) {
                    if (Directory.Exists(dirs[i])) {
                        mainDir = new DirectoryInfo(dirs[i]);
                        FileInfo[] files = mainDir.GetFiles(apps[i], SearchOption.AllDirectories);
                        foreach (FileInfo fi in files) {
                            if (browserFileInfo == null) {
                                browserFileInfo = fi;
                                sBrowser = fi.FullName;
                            }
                            else {
                                if (fi.CreationTime > browserFileInfo.CreationTime) {
                                    browserFileInfo = fi;
                                    sBrowser = fi.FullName;
                                }
                            }
                        }
                    }
                }
                if (sBrowser.Length > 0) {
                    msedgeBrowser = sBrowser;
                    execute(BROWSER.Edge, sBrowser, false);
                }
            }
        }

        private void IExplorerExecuted(object sender, ExecutedRoutedEventArgs e) {
            string sBrowser = "iexplore.exe";
            execute(BROWSER.None, sBrowser, false);
        }



        private void Browser7Executed(object sender, ExecutedRoutedEventArgs e) {
            //if (File.Exists(SingVar.Broswer7))
                execute(BROWSER.None, SingVar.Broswer7, false);
            //else
              //  Basis.ErrorMsg("Could not find the 7. Browser\r\n" + SingVar.Broswer7, "Hinweis");
        }
        private void Browser8Executed(object sender, ExecutedRoutedEventArgs e) {
            if (File.Exists(SingVar.Broswer8))
                execute(BROWSER.None, SingVar.Broswer8, false);
            else
                Basis.ErrorMsg("Could not find the 8. Browser\r\n" + SingVar.Broswer8, "Hinweis");
        }



        private void StandardBrowserExecuted(object sender, ExecutedRoutedEventArgs e) {
            execute(BROWSER.None, "", true);
        }

        private void Editor2NotepadExecuted(object sender, ExecutedRoutedEventArgs e) {
            MyTextBox edit = getActiveEditor();
            if (edit != null) {
                edit.saveFile();
                Process Prog = new Process();
                Prog.StartInfo.FileName = "Notepad.exe";
                Prog.StartInfo.Arguments = edit.getModell().Filename;
                Prog.Start();
            }
            
        }


        
        private void execute(BROWSER browser, string sBrowser, bool bStandard) {

            // String cacheFirefoxDirectory            String cacheChromeDirectory            String cacheOperaDirectory
            if (browser== BROWSER.Firefox && SingVar.DeleteCacheFirefox == 1) {
                if (Directory.Exists(cacheFirefoxDirectory)) {
                    try {
                        Directory.Delete(cacheFirefoxDirectory, true);
                    }
                    catch (Exception) {
                    }
                }

            }
            if (browser == BROWSER.Chrome && SingVar.DeleteCacheChrome == 1) {
                if (Directory.Exists(cacheChromeDirectory)) {
                    try {
                        Directory.Delete(cacheChromeDirectory, true);
                    }
                    catch (Exception) {
                    }                    
                }
            }
            if (browser == BROWSER.Opera && SingVar.DeleteCacheOpera == 1) {
                if (Directory.Exists(cacheOperaDirectory)) {
                    try {
                        Directory.Delete(cacheOperaDirectory, true);
                    }
                    catch (Exception) {
                    }                    
                }
            }


            if (sBrowser.Length>0) { 
                if (!sBrowser.StartsWith("\"") && !sBrowser.EndsWith("\"")) {
                    sBrowser = "\"" + sBrowser + "\"";
                }
            }
            MyTextBox edit = getActiveEditor();
            MyTextBox editHtml = getActiveEditor();
            if (edit != null) {
                edit.saveFile();
                edit.format();
                bool phpError = false;
                StringBuilder sb = new StringBuilder();
                // Check, ob andere php-Dateien, die zum Projekt gehören, fehlerhaft sind
                foreach (TabItem tabpage in tabcontrol.Items) {
                    MyTextBox editloop = (MyTextBox)tabpage.Content;
                    String ext = Basis.getFilenameExt(editloop.Filename).ToLower();
                    if (ext.Equals("php")) {
                        String text = editloop.getModell().EditText;
                        if (text.IndexOf("§") >= 0) {
                            phpError = true;
                            sb.AppendLine("Es gibt mindestens ein Paragraph - Zeichen(§) im Text");
                            sb.Append("  - ");
                            sb.AppendLine(Basis.getFilename(editloop.Filename));
                        }

                        String p1 = "[$][A-Za-z_][A-Za-z0-9_]{0,}(->)[$]";
                        String p2 = "[ \r\n\t][A-Za-z_][A-Za-z0-9_]{0,}\\.[A-Za-z_][A-Za-z0-9_]{0,}";
                        String p3 = "[$][A-Za-z_][A-Za-z0-9_]{0,}\\.[A-Za-z_][A-Za-z0-9_]{0,}";
                        String p4 = "[ \r\n\t][A-Za-z_][A-Za-z0-9_]{0,}(->)[A-Za-z_][A-Za-z0-9_]{0,}";

                        bool javascriptAbschnitt = false;
                        string[] splitStrings = { "\r\n" };
                        string[] lines = text.Split(splitStrings, StringSplitOptions.None);
                        StringBuilder sbb = new StringBuilder();
                        foreach(String line in lines) {                            
                            String line2 = line.Replace(Konst.C_TAB, " ");
                            if (!javascriptAbschnitt && line2.IndexOf("<script")>0) {
                                javascriptAbschnitt = true;
                            }
                            if (javascriptAbschnitt) {
                                continue;
                            }
                            if (line2.IndexOf("</script>") > 0) {
                                javascriptAbschnitt = false;
                                continue;
                            }
                            if (line2.IndexOf("header(")>0) {
                                continue;  
                            }
                            sbb.Clear();
                            sbb.Append(" ");
                            int index = line2.IndexOf(@"//");
                            if (index>0) {
                                String s = line2.Substring(0, index);
                                sbb.Append(s);
                            }
                            else {
                                sbb.Append(line2);
                            }
                            String textline = sbb.ToString();

                            if (Basis.checkPHP(sb, p1, textline, "$this->$attrib")) {
                                sb.Append("Datei: ");
                                sb.AppendLine(Basis.getFilename(editloop.Filename));
                                sb.AppendLine();
                                sb.AppendLine();
                                phpError = true;
                            }
                            if (Basis.checkPHP(sb, p2, textline, "$customer.$attrib (replace '.' into '->')")) {
                                sb.Append("Datei: ");
                                sb.AppendLine(Basis.getFilename(editloop.Filename));
                                sb.AppendLine();
                                sb.AppendLine();
                                phpError = true;
                            }
                            if (Basis.checkPHP(sb, p3, textline, "myValue.attrib (the variable must start with an $")) {
                                sb.Append("Datei: ");
                                sb.AppendLine(Basis.getFilename(editloop.Filename));
                                sb.AppendLine();
                                sb.AppendLine();
                                phpError = true;
                            }
                            if (Basis.checkPHP(sb, p4, textline, "myValue->attrib (the variable must start with an $")) {
                                sb.Append("Datei: ");
                                sb.AppendLine(Basis.getFilename(editloop.Filename));
                                sb.AppendLine();
                                sb.AppendLine();
                                phpError = true;
                            }

                        }



                    }
                }
                if (phpError) {
                    WShowMemo dialog = new WShowMemo(this, "PHP-Zeichen", "Folgende Fehler wurden festgestellt\r\n" + sb.ToString());
                    dialog.ShowDialog();
                    if (!dialog.trotzdemStarten) {
                        //dialog = new WShowMemo(this, "PHP-Zeichen", "Folgende Fehler wurden festgestellt\r\n" + sb.ToString());
                        //dialog.Show();
                        //SystemSounds.Beep.Play();
                        //SystemSounds.Beep.Play();
                        //SystemSounds.Beep.Play();
                        //SystemSounds.Beep.Play();
                        return;
                    }
                }
                // ende des Checks php auf §



                string filename = edit.getModell().Filename;
                if (Basis.getFilenameExt(filename).ToLower().Equals("css")) {
                    // suche html-child
                    String sFilename1 = Basis.changeFilenameExt(filename, "xhtml");
                    foreach (TabItem tabpage in tabcontrol.Items) {
                        edit = (MyTextBox)tabpage.Content;                        
                        if (edit.getModell().Filename.Equals(sFilename1, StringComparison.CurrentCultureIgnoreCase)) {
                            edit.saveFile();
                            edit.format();
                            editHtml = edit;
                            filename = sFilename1;
                            break;
                        }
                    }
                    sFilename1 = Basis.changeFilenameExt(filename.ToLower(), "html");
                    foreach (TabItem tabpage in tabcontrol.Items) {
                        edit = (MyTextBox)tabpage.Content;
                        if (edit.getModell().Filename.Equals(sFilename1, StringComparison.CurrentCultureIgnoreCase)) {
                            edit.saveFile();
                            edit.format();
                            editHtml = edit;
                            filename = sFilename1;
                            break;
                        }
                    }
                }
                String filenameCSS = Basis.changeFilenameExt(filename.ToLower(), "css");
                foreach (TabItem tabpage in tabcontrol.Items) {
                    edit = (MyTextBox)tabpage.Content;
                    if (edit.getModell().Filename.Equals(filenameCSS, StringComparison.CurrentCultureIgnoreCase)) {
                        edit.checkSpaces();
                        break;
                    }
                }

                String param = filename;
                if (mnPHP_JSP_Direct.IsChecked && tabcontrol.Items.Count>0) {
                    TabItem tabpage = (TabItem)tabcontrol.Items[0];
                    edit = (MyTextBox)tabpage.Content;
                    String ext = Basis.getFilenameExt(edit.Filename).ToLower();
                    if (ext.Equals("php")) {
                        bool gefunden = false;
                        Process[] ProgrammTask = Process.GetProcesses();
                        foreach (Process scannTask in ProgrammTask) {
                            if (scannTask.ProcessName.Equals("xampp-control")) {
                                gefunden = true;
                            }
                            if (scannTask.ProcessName.Equals("httpd")) {
                                gefunden = true;
                            }
                        }
                        // httpd.exe
                        if (!gefunden) {
                            Basis.Message("Bitte starten Sie  xampp-control.exe", "Hinweis");
                            return;
                        }
                    }

                    if (ext.Equals("php") || ext.Equals("xhtml") || ext.Equals("htm") || ext.Equals("html") || ext.Equals("jsp")) {
                        // localhost:8080/AufgabePHP1/aufgabe1.php
                        // C:\xampp\htdocs\AufgabePHP1\labor_tabelle.php
                        int posi = edit.Filename.ToLower().IndexOf("htdocs\\");
                        if (posi > 0) {
                            if (sBrowser.ToLower().Contains("firefox.exe")) 
                                param = "localhost:"+ SingVar.Phpport+"/" + edit.Filename.Substring(posi + 7).Replace("\\", "/");
                            else
                                param = "127.0.0.1:" + SingVar.Phpport + "/" + edit.Filename.Substring(posi + 7).Replace("\\", "/");
                        }
                        else {
                            // c:\xampp\tomcat\webapps\ROOT\JSP1.jsp
                            posi = edit.Filename.IndexOf("ROOT\\");
                            if (posi > 0) {
                                if (sBrowser.ToLower().Contains("firefox.exe"))
                                    param = "localhost:" + SingVar.Jspport + "/" + edit.Filename.Substring(posi + 5).Replace("\\", "/");
                                else
                                    param = "127.0.0.1:" + SingVar.Jspport + "/" + edit.Filename.Substring(posi + 5).Replace("\\", "/");
                            }
                            else {
                                // c:\xampp\tomcat\webapps\examples\servlets\index.html
                                posi = edit.Filename.IndexOf("webapps\\");
                                if (posi > 0) {
                                    if (sBrowser.ToLower().Contains("firefox.exe"))
                                        param = "localhost:" + SingVar.Phpport + "/" + edit.Filename.Substring(posi + 8).Replace("\\", "/");
                                    else
                                        param = "127.0.0.1:" + SingVar.Phpport + "/" + edit.Filename.Substring(posi + 8).Replace("\\", "/");
                                }
                            }
                        }
                    }
                }
                else {
                    if (Basis.getFilenameExt(filename).ToLower().Equals("php")) {
                        // localhost:8080/AufgabePHP1/aufgabe1.php
                        // C:\xampp\htdocs\AufgabePHP1\labor_tabelle.php
                        int posi = filename.ToLower().IndexOf("htdocs\\");
                        if (posi > 0) {
                            param = "localhost:8080/" + filename.Substring(posi + 7).Replace("\\", "/");
                        }
                    }
                    else {
                        param = "\"" + filename + "\"";
                    }
                }

                // iexplore.exe

                if (editHtml.compile()) {
                    try {
                        Process Prog = new Process();
                        if (bStandard) {
                            Prog.StartInfo.FileName = param;
                            Prog.StartInfo.Arguments = "";
                        }
                        else {

                            Prog.StartInfo.FileName = sBrowser;
                            Prog.StartInfo.Arguments = param;
                        }
                        Prog.Start();
                    }
                    catch (Exception e) {
                        Basis.ErrorMsg("Der Browser konnte nicht gestartet werden:\r\n" + sBrowser+"\r\n"+e.ToString(), "Fehler");
                    }
                }
            }
        }  // execute

        private void Register2LeftExecuted(object sender, ExecutedRoutedEventArgs e) {
            int index = tabcontrol.SelectedIndex;
            if (index > 0) {
                TabItem tabpage = (TabItem)tabcontrol.Items[index];
                tabcontrol.Items.RemoveAt(index);
                tabcontrol.Items.Insert(index-1, tabpage);
                tabcontrol.SelectedIndex = index - 1;
                //tabpage = (TabItem)tabcontrol.Items[index - 1];
                //((MyTextBox)tabpage.Content).setFocus();
            }
        }

        private void Register2RightExecuted(object sender, ExecutedRoutedEventArgs e) {
            int index = tabcontrol.SelectedIndex;
            if (index < (tabcontrol.Items.Count-1)) {
                TabItem tabpage = (TabItem)tabcontrol.Items[index];
                tabcontrol.Items.RemoveAt(index);
                tabcontrol.Items.Insert(index+ 1, tabpage);
                tabcontrol.SelectedIndex = index + 1;
                //tabpage = (TabItem)tabcontrol.Items[index+1];
                //((MyTextBox)tabpage.Content).setFocus();
            }
        }

     

        private void CloseRegisterExecuted(object sender, ExecutedRoutedEventArgs e) {            
            MyTextBox edit;
            int index = tabcontrol.SelectedIndex;
            if (index >= 0) {
                TabItem tabpage = (TabItem)tabcontrol.Items[index];
                edit = (MyTextBox)tabpage.Content;
                if (edit.getModell().Modified) {
                    MessageBoxResult res = Basis.readYesNoCancel("Save the changes?", "Close the programm");
                    switch (res) {
                        case MessageBoxResult.Yes: edit.saveFile();
                            break;
                        case MessageBoxResult.No:
                            break;
                        case MessageBoxResult.Cancel: return;
                    }
                }
                tabcontrol.Items.RemoveAt(index);
            }

        } // closeRegister

        private void TabItem_PreviewMouseMove(object sender, MouseEventArgs e) {
            var tabItem = e.Source as MyTabItem;

            if (tabItem == null)
                return;

            if (Mouse.PrimaryDevice.LeftButton == MouseButtonState.Pressed) {
                DragDrop.DoDragDrop(tabItem, tabItem, DragDropEffects.All);
            }
        }


        private void TabItem_Drop(object sender, DragEventArgs e) {
            var tabItemTarget = e.Source as MyTabItem;

            var tabItemSource = e.Data.GetData(typeof(MyTabItem)) as MyTabItem;

            if (!tabItemTarget.Equals(tabItemSource)) {
                var tabControl = tabItemTarget.Parent as TabControl;
                int sourceIndex = tabcontrol.Items.IndexOf(tabItemSource);
                int targetIndex = tabcontrol.Items.IndexOf(tabItemTarget);

                tabcontrol.Items.Remove(tabItemSource);
                tabcontrol.Items.Insert(targetIndex, tabItemSource);

                tabcontrol.Items.Remove(tabItemTarget);
                tabcontrol.Items.Insert(sourceIndex, tabItemTarget);
            }
        }

        //private void TabItem_PreviewMouseMove(object sender, MouseEventArgs e) {
        //    var tabItem = e.Source as TabItem;

        //    if (tabItem == null)
        //        return;

        //    if (Mouse.PrimaryDevice.LeftButton == MouseButtonState.Pressed) {
        //        DragDrop.DoDragDrop(tabItem, tabItem, DragDropEffects.All);
        //    }
        //}


        //private void TabItem_Drop(object sender, DragEventArgs e) {
        //    var tabItemTarget = e.Source as TabItem;

        //    var tabItemSource = e.Data.GetData(typeof(TabItem)) as TabItem;

        //    if (!tabItemTarget.Equals(tabItemSource)) {
        //        var tabControl = tabItemTarget.Parent as TabControl;
        //        int sourceIndex = tabControl.Items.IndexOf(tabItemSource);
        //        int targetIndex = tabControl.Items.IndexOf(tabItemTarget);

        //        tabControl.Items.Remove(tabItemSource);
        //        tabControl.Items.Insert(targetIndex, tabItemSource);

        //        tabControl.Items.Remove(tabItemTarget);
        //        tabControl.Items.Insert(sourceIndex, tabItemTarget);
        //    }
        //}


        private void CalcExecuted(object sender, ExecutedRoutedEventArgs e) {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "Calc.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start();
        }
        private void NotepadExecuted(object sender, ExecutedRoutedEventArgs e) {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "Notepad.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start();
        }

        private void CheckXampp() {
            if (mnPHP_JSP_Direct.IsChecked) {
                Process[] ProgrammTask = Process.GetProcesses();
                bool xampp = false;
                foreach (Process scannTask in ProgrammTask) {
                    if (scannTask.ProcessName.Equals("xampp-control")) {
                        xampp = true;
                    }
                } // foreach
                if (!xampp) {
                    Basis.Message("Bitte starten xampp.exe", "Hinweis");
                }
            } // if
        }


        private void mnPHP_JSP_Direct_Click(object sender, RoutedEventArgs e)  {
            mnPHP_JSP_Direct.IsChecked = !mnPHP_JSP_Direct.IsChecked;
            CheckXampp();
        }

        private void Window_PreviewMouseWheel(Object sender, MouseWheelEventArgs e) {
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Control)) {
                //Title = e.Delta.ToString();
                e.Handled = true;
                if (e.Delta > 0) {
                    editorfontsize += 2;
                    if (editorfontsize > 58) editorfontsize = 58;
                }
                else {
                    editorfontsize -= 2;
                    if (editorfontsize < 8) editorfontsize = 8;
                }
                setEditorFontsizeRegistry(editorfontsize);
            }
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Shift)) {
                //Title = e.Delta.ToString();
                e.Handled = true;
                if (e.Delta > 0) {
                    mainfontsize += 2;
                    if (mainfontsize > 58) mainfontsize = 58;
                }
                else {
                    mainfontsize -= 2;
                    if (mainfontsize < 8) mainfontsize = 8;
                }
                setFontsizeRegistry(mainfontsize);
            }
        }
        

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            MyTextBox edit;
            foreach (TabItem tabpage in tabcontrol.Items) {
                edit = (MyTextBox)tabpage.Content;
                if (edit.getModell().Modified) {
                    MessageBoxResult res = Basis.readYesNoCancel("Save the changes?", "Close the programm");
                    switch (res) {
                        case MessageBoxResult.Yes:
                            edit.saveFile();
                            break;
                        case MessageBoxResult.No:
                            break;
                        case MessageBoxResult.Cancel:
                            e.Cancel = true;
                            break;
                    }
                }
            }
            OldFiles oldfiles = OldFiles.getInstance();
            Basis.writeWindowPosition2Registry(this, SingVar.C_REG_ADR, dialogname);

        }

    }
}
