﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace HtmlWpfRtf.Common {
    /// <summary>
    /// Interaktionslogik für FInputString.xaml
    /// </summary>
    public partial class WInputString : Window {

        private bool bRetCode = false;

        public bool Retcode {
            get { return bRetCode; }
        }

        public String NameOfFunction {
            get { return tName.Text.Trim(); }
        }


        public WInputString() {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tName.Focus();
        }


        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
        }


        private void bnOk_Click(object sender, RoutedEventArgs e) {
            bRetCode = true;
            Close();
        }

        private void bnCancel_Click(object sender, RoutedEventArgs e) {
            Close();
        }


    }
}
