﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace HtmlWpfRtf.Common {
    /// <summary>
    /// Interaction logic for WReadXMLHttpRequest.xaml
    /// </summary>
    public partial class WReadXMLHttpRequest : Window {

        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        public String getSuffix() {
            return tSuffix.Text.Trim();
        }

        public WReadXMLHttpRequest(Window parent) {
            InitializeComponent();
            tSuffix.Text = "1";
            this.Owner = parent;  // Important, because CenterOwner            
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tSuffix.Focus();
        }

        private void tSuffix_TextChanged(Object sender, TextChangedEventArgs e) {
            String suffix = tSuffix.Text.Trim();
            tXMLHttpRequest.Text = "xmlhttp" + suffix;
            tJason.Text = "receiveJson" + suffix;
        }


        private void bnOk_Click(object sender, RoutedEventArgs e) {
            String newFile = tSuffix.Text.Trim();
            if (Basis.CheckDateinamen(newFile)) {
                retcode = true;
                Close();
            }
            else {
                Basis.ErrorMsg("Der neue Name ist nicht gültig", "Hinweis");
            }
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                bnEsc_Click(sender, e);
            }
        }

    }
}