﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Collections;

using System.IO;
using System.Windows;


namespace HtmlWpfRtf {
    class SingVar {
        public static string C_REG_ADR = "SOFTWARE\\WILHELM\\HtmlWpf";

        public static String search = "";
        public static Boolean ignoreCase1 = false;
        public static Boolean wholeword = false;

        public static String replace = "";


        public static String C_NONAME = "noname";

        private static string sBroswer7 = "";
        private static string sBroswer8 = "";

        private static string fontfamily = "Consolas";
        public static string Fontfamily {
            get { return fontfamily; }
            set {
                fontfamily = value;
                Basis.WriteRegString(C_REG_ADR, "fontfamily", fontfamily);
            }
        }

        private static string phpport = "80";
        public static string Phpport {
            get { return phpport; }
            set {
                phpport = value;
                Basis.WriteRegString(C_REG_ADR, "phpport", phpport);
            }
        }
        private static string jspport = "8080";
        public static string Jspport {
            get { return jspport; }
            set {
                jspport = value;
                Basis.WriteRegString(C_REG_ADR, "jspport", jspport);
            }
        }



        // public ArrayList files = new ArrayList();

        private static  int iTabNr = 0;
        public static int TabNr {
            get { return iTabNr; }
            set {
                if (value>=0 && value< Konst.C_TABS.Length) {
                    iTabNr = value;
                    Basis.WriteRegInt(C_REG_ADR, "iTabNr", iTabNr);
                    setTabnr();
                }
            }
        }

        private static  void setTabnr() {
            if (iTabNr>=0 && iTabNr< Konst.C_TABS.Length) {
                Konst.C_TAB = Konst.C_TABS[iTabNr];
            }
            else {
                iTabNr = 0;
                Konst.C_TAB = Konst.C_TABS[0];
            }
        }


        private static  int fontcolorRed = 0; // Color.Black;
        public static int FontcolorRed {
            get { return fontcolorRed; }
            set {
                fontcolorRed = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolorRed", fontcolorRed);
                Basis.WriteRegBool(C_REG_ADR, "isSetFontColor", true);
            }

        }

        private static  int fontcolorGreen = 0; // Color.Black;
        public static int FontcolorGreen {
            get { return fontcolorGreen; }
            set {
                fontcolorGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolorGreen", fontcolorGreen);
                Basis.WriteRegBool(C_REG_ADR, "isSetFontColor", true);
            }

        }

        private static  int fontcolorBlue = 0; // Color.Black;
        public static int FontcolorBlue {
            get { return fontcolorBlue; }
            set {
                fontcolorBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolorBlue", fontcolorBlue);
                Basis.WriteRegBool(C_REG_ADR, "isSetFontColor", true);
            }

        }




        private static  int bgcolorRed = 255;
        public static int BGcolorRed {
            get { return bgcolorRed; }
            set {
                bgcolorRed = value;
                Basis.WriteRegInt(C_REG_ADR, "bgcolorRed", bgcolorRed);
                Basis.WriteRegBool(C_REG_ADR, "isSetBGColor", true);
            }

        }

        private static int bgcolorGreen = 255;
        public static int BGcolorGreen {
            get { return bgcolorGreen; }
            set {
                bgcolorGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "bgcolorGreen", bgcolorGreen);
                Basis.WriteRegBool(C_REG_ADR, "isSetBGColor", true);
            }

        }

        private static int bgcolorBlue = 255;
        public static int BGcolorBlue {
            get { return bgcolorBlue; }
            set {
                bgcolorBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "bgcolorBlue", bgcolorBlue);
                Basis.WriteRegBool(C_REG_ADR, "isSetBGColor", true);
            }

        }



        private static int fontcolordialogBackgroundRed = 240; // Color.Black;
        public static int FontcolordialogBackgroundRed {
            get { return fontcolordialogBackgroundRed; }
            set {
                fontcolordialogBackgroundRed = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolordialogBackgroundRed", fontcolordialogBackgroundRed);
                Basis.WriteRegBool(C_REG_ADR, "isfontcolordialogBackgroundRed", true);
            }

        }
        private static int fontcolordialogBackgroundGreen = 240; // Color.Black;
        public static int FontcolordialogBackgroundGreen {
            get { return fontcolordialogBackgroundGreen; }
            set {
                fontcolordialogBackgroundGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolordialogBackgroundGreen", fontcolordialogBackgroundGreen);
                Basis.WriteRegBool(C_REG_ADR, "isfontcolordialogBackgroundGreen", true);
            }

        }
        private static int fontcolordialogBackgroundBlue = 240; // Color.Black;
        public static int FontcolordialogBackgroundBlue {
            get { return fontcolordialogBackgroundBlue; }
            set {
                fontcolordialogBackgroundBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "fontcolordialogBackgroundBlue", fontcolordialogBackgroundBlue);
                Basis.WriteRegBool(C_REG_ADR, "isfontcolordialogBackgroundBlue", true);
            }

        }




        private static int lineNumberColordialogForegroundRed = 44; // Color.Black;
        public static int LineNumberColordialogForegroundRed {
            get { return lineNumberColordialogForegroundRed; }
            set {
                lineNumberColordialogForegroundRed = value;
                Basis.WriteRegInt(C_REG_ADR, "lineNumberColordialogForegroundRed", lineNumberColordialogForegroundRed);
                Basis.WriteRegBool(C_REG_ADR, "islineNumberColordialogForegroundRed", true);
            }
        }
        private static int lineNumberColordialogForegroundGreen = 160; // Color.Black;
        public static int LineNumberColordialogForegroundGreen {
            get { return lineNumberColordialogForegroundGreen; }
            set {
                lineNumberColordialogForegroundGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "lineNumberColordialogForegroundGreen", lineNumberColordialogForegroundGreen);
                Basis.WriteRegBool(C_REG_ADR, "islineNumberColordialogForegroundGreen", true);
            }

        }
        private static int lineNumberColordialogForegroundBlue = 204; // Color.Black;
        public static int LineNumberColordialogForegroundBlue {
            get { return lineNumberColordialogForegroundBlue; }
            set {
                lineNumberColordialogForegroundBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "lineNumberColordialogForegroundBlue", lineNumberColordialogForegroundBlue);
                Basis.WriteRegBool(C_REG_ADR, "islineNumberColordialogForegroundBlue", true);
            }

        }


        private static int htmlColordialogForegroundRed = 0; 
        public static int HtmlColordialogForegroundRed {
            get { return htmlColordialogForegroundRed; }
            set {
                htmlColordialogForegroundRed = value;
                Basis.WriteRegInt(C_REG_ADR, "htmlColordialogForegroundRed", htmlColordialogForegroundRed);
                Basis.WriteRegBool(C_REG_ADR, "ishtmlColordialogForegroundRed", true);
            }
        }
        private static int htmlColordialogForegroundGreen = 0;
        public static int HtmlColordialogForegroundGreen {
            get { return htmlColordialogForegroundGreen; }
            set {
                htmlColordialogForegroundGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "htmlColordialogForegroundGreen", htmlColordialogForegroundGreen);
                Basis.WriteRegBool(C_REG_ADR, "ishtmlColordialogForegroundGreen", true);
            }
        }
        private static int htmlColordialogForegroundBlue = 255;
        public static int HtmlColordialogForegroundBlue {
            get { return htmlColordialogForegroundBlue; }
            set {
                htmlColordialogForegroundBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "htmlColordialogForegroundBlue", htmlColordialogForegroundBlue);
                Basis.WriteRegBool(C_REG_ADR, "ishtmlColordialogForegroundBlue", true);
            }
        }


        
        private static int normalTextColordialogForegroundRed = 0;
        public static int NormalTextColordialogForegroundRed {
            get { return normalTextColordialogForegroundRed; }
            set {
                normalTextColordialogForegroundRed = value;
                Basis.WriteRegInt(C_REG_ADR, "normalTextColordialogForegroundRed", normalTextColordialogForegroundRed);
                Basis.WriteRegBool(C_REG_ADR, "isnormalTextColordialogForegroundRed", true);
            }
        }
        private static int normalTextColordialogForegroundGreen = 128;
        public static int NormalTextColordialogForegroundGreen {
            get { return normalTextColordialogForegroundGreen; }
            set {
                normalTextColordialogForegroundGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "normalTextColordialogForegroundGreen", normalTextColordialogForegroundGreen);
                Basis.WriteRegBool(C_REG_ADR, "isnormalTextColordialogForegroundGreen", true);
            }
        }
        private static int normalTextColordialogForegroundBlue = 64;
        public static int NormalTextColordialogForegroundBlue {
            get { return normalTextColordialogForegroundBlue; }
            set {
                normalTextColordialogForegroundBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "normalTextColordialogForegroundBlue", normalTextColordialogForegroundBlue);
                Basis.WriteRegBool(C_REG_ADR, "isnormalTextColordialogForegroundBlue", true);
            }
        }



        
        private static int specialCharactersColordialogForegroundRed = 255;
        public static int SpecialCharactersColordialogForegroundRed {
            get { return specialCharactersColordialogForegroundRed; }
            set {
                specialCharactersColordialogForegroundRed = value;
                Basis.WriteRegInt(C_REG_ADR, "specialCharactersColordialogForegroundRed", specialCharactersColordialogForegroundRed);
                Basis.WriteRegBool(C_REG_ADR, "isspecialCharactersColordialogForegroundRed", true);
            }
        }
        private static int specialCharactersColordialogForegroundGreen = 0;
        public static int SpecialCharactersColordialogForegroundGreen {
            get { return specialCharactersColordialogForegroundGreen; }
            set {
                specialCharactersColordialogForegroundGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "specialCharactersColordialogForegroundGreen", specialCharactersColordialogForegroundGreen);
                Basis.WriteRegBool(C_REG_ADR, "isspecialCharactersColordialogForegroundGreen", true);
            }
        }
        private static int specialCharactersColordialogForegroundBlue = 0;
        public static int SpecialCharactersColordialogForegroundBlue {
            get { return specialCharactersColordialogForegroundBlue; }
            set {
                specialCharactersColordialogForegroundBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "specialCharactersColordialogForegroundBlue", specialCharactersColordialogForegroundBlue);
                Basis.WriteRegBool(C_REG_ADR, "isspecialCharactersColordialogForegroundBlue", true);
            }
        }




        private static int commentColordialogForegroundRed = 183;
        public static int CommentColordialogForegroundRed {
            get { return commentColordialogForegroundRed; }
            set {
                commentColordialogForegroundRed = value;
                Basis.WriteRegInt(C_REG_ADR, "commentColordialogForegroundRed", commentColordialogForegroundRed);
                Basis.WriteRegBool(C_REG_ADR, "iscommentColordialogForegroundRed", true);
            }
        }
        private static int commentColordialogForegroundGreen = 60;
        public static int CommentColordialogForegroundGreen {
            get { return commentColordialogForegroundGreen; }
            set {
                commentColordialogForegroundGreen = value;
                Basis.WriteRegInt(C_REG_ADR, "commentColordialogForegroundGreen", commentColordialogForegroundGreen);
                Basis.WriteRegBool(C_REG_ADR, "iscommentColordialogForegroundGreen", true);
            }
        }
        private static int commentColordialogForegroundBlue = 0;
        public static int CommentColordialogForegroundBlue {
            get { return commentColordialogForegroundBlue; }
            set {
                commentColordialogForegroundBlue = value;
                Basis.WriteRegInt(C_REG_ADR, "commentColordialogForegroundBlue", commentColordialogForegroundBlue);
                Basis.WriteRegBool(C_REG_ADR, "iscommentColordialogForegroundBlue", true);
            }
        }



        private static bool colorEditorAktualiserung = true;
        public static bool ColorEditorAktualiserung {
            get { return colorEditorAktualiserung; }
            set {
                colorEditorAktualiserung = value;
                Basis.WriteRegBool(C_REG_ADR, "colorEditorAktualiserung", colorEditorAktualiserung);
                Basis.WriteRegBool(C_REG_ADR, "iscolorEditorAktualiserung", true);
            }
        }

        private static bool bWordWrap = false;


        private static int iTop = 0;
        private static int iLeft = 0;
        private static int iWidth = 800;
        private static int iHeight = 600;
        private static bool bSetting = false;
        private static bool bStartDirComplete = true;

        private static bool bReplaceJumps = false;

        private static String lastPath = "";

        public static String LastPath {
            get { return lastPath; }
            set { 
                lastPath = value;
                Basis.WriteRegString(C_REG_ADR, "lastPath", lastPath);
            }
        }

        public static bool ReplaceJumps {
            get { return bReplaceJumps; }
            set {
                bReplaceJumps = value;
                Basis.WriteRegBool(C_REG_ADR, "bReplaceJumps", bReplaceJumps);
            }
        }


        public static bool Setting
        {
            get { return bSetting; }
            set
            {
                bSetting = value;
                Basis.WriteRegBool(C_REG_ADR, "bSetting", bSetting);
            }
        }




        // ------------------



        public static bool WordWrap
        {
            get { return bWordWrap; }
            set
            {
                bWordWrap = value;
                Basis.WriteRegBool(C_REG_ADR, "bWordWrap", bWordWrap);
            }
        }


        
        // -----------


        public static string Broswer7 {
            get { return sBroswer7; }
            set {
                sBroswer7 = value;
                Basis.WriteRegString(C_REG_ADR, "Broswer7", sBroswer7);
            }
        }
        public static string Broswer8 {
            get { return sBroswer8; }
            set {
                sBroswer8 = value;
                Basis.WriteRegString(C_REG_ADR, "Broswer8", sBroswer8);
            }
        }

        
        private static int deleteCacheFirefox = 0;   // 0 nicht löschen
        public static int DeleteCacheFirefox {
            get { return deleteCacheFirefox; }
            set {
                deleteCacheFirefox = value;
                Basis.WriteRegInt(C_REG_ADR, "deleteCacheFirefox", deleteCacheFirefox);               
            }

        }

        private static int deleteCacheChrome = 0;   // 0 nicht löschen
        public static int DeleteCacheChrome {
            get { return deleteCacheChrome; }
            set {
                deleteCacheChrome = value;
                Basis.WriteRegInt(C_REG_ADR, "deleteCacheChrome", deleteCacheChrome);
            }

        }

        private static int deleteCacheOpera = 0;   // 0 nicht löschen
        public static int DeleteCacheOpera {
            get { return deleteCacheOpera; }
            set {
                deleteCacheOpera = value;
                Basis.WriteRegInt(C_REG_ADR, "deleteCacheOpera", deleteCacheOpera);
            }

        }


        static SingVar()   {
            iTabNr = Basis.ReadRegInt(C_REG_ADR, "iTabNr");
            if (iTabNr < 0 || iTabNr>= Konst.C_TABS.Length) iTabNr = 0;
            setTabnr();

            bWordWrap = Basis.ReadRegBool(C_REG_ADR, "bWordWrap");
            bStartDirComplete = Basis.ReadRegBool(C_REG_ADR, "bStartDirComplete");

            bSetting = Basis.ReadRegBool(C_REG_ADR, "bSetting");
            iTop = Basis.ReadRegInt(C_REG_ADR, "iTop");
            iLeft = Basis.ReadRegInt(C_REG_ADR, "iLeft");
            iWidth = Basis.ReadRegInt(C_REG_ADR, "iWidth");
            iHeight = Basis.ReadRegInt(C_REG_ADR, "iHeight");

            bReplaceJumps = Basis.ReadRegBool(C_REG_ADR, "bReplaceJumps");

            
            String dummy = Basis.ReadRegString(C_REG_ADR, "fontfamily");
            if (dummy.Length > 0) {
                fontfamily = dummy;
            }

            
            sBroswer7 = Basis.ReadRegString(C_REG_ADR, "Broswer7");
            sBroswer8 = Basis.ReadRegString(C_REG_ADR, "Broswer8");

            deleteCacheFirefox = Basis.ReadRegInt(C_REG_ADR, "deleteCacheFirefox");
            deleteCacheChrome = Basis.ReadRegInt(C_REG_ADR, "deleteCacheChrome");
            deleteCacheOpera = Basis.ReadRegInt(C_REG_ADR, "deleteCacheOpera");


            dummy = Basis.ReadRegString(C_REG_ADR, "phpport");
            if (dummy.Length > 0) {
                phpport = dummy;
            }
            dummy = Basis.ReadRegString(C_REG_ADR, "jspport");
            if (dummy.Length > 0) {
                jspport = dummy;
            }

            lastPath = Basis.ReadRegString(C_REG_ADR, "lastPath");
            
            if (lastPath.Length == 0 || !Directory.Exists(lastPath)) {
                lastPath = System.Environment.CurrentDirectory;
            }
            else {
                if (!IsDirectoryWritable(lastPath)) {
                    lastPath = System.Environment.CurrentDirectory;
                }
                //System.Security.AccessControl.DirectorySecurity access = Directory.GetAccessControl(lastPath);
               // if (access.)
            }


            if (Basis.ReadRegBool(C_REG_ADR, "isSetFontColor")) {
                fontcolorRed = Basis.ReadRegInt(C_REG_ADR, "fontcolorRed");
                fontcolorGreen = Basis.ReadRegInt(C_REG_ADR, "fontcolorGreen");
                fontcolorBlue = Basis.ReadRegInt(C_REG_ADR, "fontcolorBlue");
            }

            if (Basis.ReadRegBool(C_REG_ADR, "isSetBGColor")) {
                bgcolorRed = Basis.ReadRegInt(C_REG_ADR, "bgcolorRed");
                bgcolorGreen = Basis.ReadRegInt(C_REG_ADR, "bgcolorGreen");
                bgcolorBlue = Basis.ReadRegInt(C_REG_ADR, "bgcolorBlue");
            }

            if (Basis.ReadRegBool(C_REG_ADR, "isfontcolordialogBackgroundRed")) {
                FontcolordialogBackgroundRed = Basis.ReadRegInt(C_REG_ADR, "fontcolordialogBackgroundRed");
                FontcolordialogBackgroundGreen = Basis.ReadRegInt(C_REG_ADR, "fontcolordialogBackgroundGreen");
                FontcolordialogBackgroundBlue = Basis.ReadRegInt(C_REG_ADR, "fontcolordialogBackgroundBlue");
            }

            if (Basis.ReadRegBool(C_REG_ADR, "islineNumberColordialogForegroundRed")) {
                LineNumberColordialogForegroundRed = Basis.ReadRegInt(C_REG_ADR, "lineNumberColordialogForegroundRed");
                LineNumberColordialogForegroundGreen = Basis.ReadRegInt(C_REG_ADR, "lineNumberColordialogForegroundGreen");
                LineNumberColordialogForegroundBlue = Basis.ReadRegInt(C_REG_ADR, "lineNumberColordialogForegroundBlue");
            }


            if (Basis.ReadRegBool(C_REG_ADR, "ishtmlColordialogForegroundRed")) {
                htmlColordialogForegroundRed = Basis.ReadRegInt(C_REG_ADR, "htmlColordialogForegroundRed");
                htmlColordialogForegroundGreen = Basis.ReadRegInt(C_REG_ADR, "htmlColordialogForegroundGreen");
                htmlColordialogForegroundBlue = Basis.ReadRegInt(C_REG_ADR, "htmlColordialogForegroundBlue");
            }


            
            if (Basis.ReadRegBool(C_REG_ADR, "isnormalTextColordialogForegroundRed")) {
                normalTextColordialogForegroundRed = Basis.ReadRegInt(C_REG_ADR, "normalTextColordialogForegroundRed");
                normalTextColordialogForegroundGreen = Basis.ReadRegInt(C_REG_ADR, "normalTextColordialogForegroundGreen");
                normalTextColordialogForegroundBlue = Basis.ReadRegInt(C_REG_ADR, "normalTextColordialogForegroundBlue");
            }


            if (Basis.ReadRegBool(C_REG_ADR, "isspecialCharactersColordialogForegroundRed")) {
                specialCharactersColordialogForegroundRed = Basis.ReadRegInt(C_REG_ADR, "specialCharactersColordialogForegroundRed");
                specialCharactersColordialogForegroundGreen = Basis.ReadRegInt(C_REG_ADR, "specialCharactersColordialogForegroundGreen");
                specialCharactersColordialogForegroundBlue = Basis.ReadRegInt(C_REG_ADR, "specialCharactersColordialogForegroundBlue");
            }

            if (Basis.ReadRegBool(C_REG_ADR, "iscommentColordialogForegroundRed")) {
                commentColordialogForegroundRed = Basis.ReadRegInt(C_REG_ADR, "commentColordialogForegroundRed");
                commentColordialogForegroundGreen = Basis.ReadRegInt(C_REG_ADR, "commentColordialogForegroundGreen");
                commentColordialogForegroundBlue = Basis.ReadRegInt(C_REG_ADR, "commentColordialogForegroundBlue");
            }


            if (Basis.ReadRegBool(C_REG_ADR, "iscolorEditorAktualiserung")) {
                colorEditorAktualiserung = Basis.ReadRegBool(C_REG_ADR, "colorEditorAktualiserung");
            }

        }



        private static bool IsDirectoryWritable(string dirPath)   {
            try {
                using (FileStream fs = File.Create(
                    Path.Combine(
                        dirPath,
                        Path.GetRandomFileName()
                    ),
                    1,
                    FileOptions.DeleteOnClose)
                ) { }
                return true;
            }
            catch {
               return false;
            }
        }

        // GridGrid
        private static  String getFlexLayoutHTML(int layout, String cssfilename)   {
            StringBuilder sb = new StringBuilder();
            switch (layout) {
                case 1:  // Grid horizontal
                    sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
                    sb.AppendLine("<!DOCTYPE html");
                    sb.AppendLine("  PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
                    sb.AppendLine("  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
                    sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
                    sb.AppendLine("<head>");
                    sb.AppendLine(Konst.C_TAB + "<title> Beispiel 1 </title>");
                    sb.AppendLine(Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<link rel=\"stylesheet\"");
                    sb.AppendLine(Konst.C_TAB + "type=\"text/css\"  href=\"" + cssfilename+ "\" title=\"style1\"/>");
                    sb.AppendLine("</head>");
                    sb.AppendLine();
                    sb.AppendLine("<body>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<div id=\"wrapper\">");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<header class=\"aussehen\"  >Head</header>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<section class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<h2>Content</h2>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "more content");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</section>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<aside  class=\"aussehen\" >Footer</aside>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</div>");
                    sb.AppendLine();
                    sb.AppendLine("</body>");
                    sb.AppendLine();
                    sb.AppendLine("</html>");
                    break;
                case 2:   // Grid vertikal
                    sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
                    sb.AppendLine("<!DOCTYPE html");
                    sb.AppendLine("  PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
                    sb.AppendLine("  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
                    sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
                    sb.AppendLine("<head>");
                    sb.AppendLine(Konst.C_TAB + "<title> Beispiel 1 </title>");
                    sb.AppendLine(Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
                    sb.AppendLine(Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
                    sb.AppendLine(Konst.C_TAB + "<link rel=\"stylesheet\"   type=\"text/css\"  href=\"" + cssfilename + "\" title=\"style1\"/>");
                    sb.AppendLine("</head>");
                    sb.AppendLine();
                    sb.AppendLine("<body>");
                    sb.AppendLine(Konst.C_TAB + "<div id=\"wrapper\">");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<header  class=\"aussehen\"  >Head</header>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<article class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<h2>Content</h2>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "more content");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</article>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<footer class=\"aussehen\" >Footer</footer>");
                    sb.AppendLine(Konst.C_TAB + "</div>");
                    sb.AppendLine();
                    sb.AppendLine("</body>");
                    sb.AppendLine();
                    sb.AppendLine("</html>");
                    break;
                case 3:  // Grid normal
                    sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
                    sb.AppendLine("<!DOCTYPE html");
                    sb.AppendLine("  PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
                    sb.AppendLine("  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
                    sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
                    sb.AppendLine("<head>");
                    sb.AppendLine(Konst.C_TAB + "<title> Beispiel 1 </title>");
                    sb.AppendLine(Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
                    sb.AppendLine(Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
                    sb.AppendLine(Konst.C_TAB + "<link rel=\"stylesheet\"  type=\"text/css\"  href=\"" + cssfilename + "\" title=\"style1\"/>");
                    sb.AppendLine("</head>");
                    sb.AppendLine();
                    sb.AppendLine("<body>");
                    sb.AppendLine(Konst.C_TAB + "<div id=\"wrapper\" >");
                    sb.AppendLine();
                    sb.AppendLine(Konst.C_TAB + "<header  class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Head");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"http://www.miwilhelm.de\" >    <em>Die Seite</em>  </a>  &#160; | &#160;&#160;  ");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"http://www.hs-harz.de/index.html\" target=\"_blank\">    HS-Harz   </a> &#160; | &#160;&#160;  ");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"http://www.bing.de\" target=\"_blank\">  Bing</a>");
                    sb.AppendLine(Konst.C_TAB + "</header>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<nav class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "Navigator");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<ol>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"http://www.miwilhelm.de\" target=\"_blank\" >    <em>Die Seite</em>  </a></li>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"http://www.hs-harz.de/index.html\" target=\"_blank\">    HS-Harz   </a></li>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"http://www.google.de\" target=\"_blank\"> Google  </a></li>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</ol>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</nav>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<article class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<h2>Content</h2>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "more content");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</article>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<footer class=\"aussehen\" >Footer</footer>");
                    sb.AppendLine(Konst.C_TAB + "</div>");
                    sb.AppendLine();
                    sb.AppendLine("</body>");
                    sb.AppendLine();
                    sb.AppendLine("</html>");
                    break;



                case 4:  // horizontal
                    sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
                    sb.AppendLine("<!DOCTYPE html");
                    sb.AppendLine("  PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
                    sb.AppendLine("  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
                    sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
                    sb.AppendLine("<head>");
                    sb.AppendLine(Konst.C_TAB + "<title> Beispiel 1 </title>");
                    sb.AppendLine(Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<link rel=\"stylesheet\"");
                    sb.AppendLine(Konst.C_TAB + "type=\"text/css\"  href=\"" + cssfilename + "\" title=\"style1\"/>");
                    sb.AppendLine("</head>");
                    sb.AppendLine();
                    sb.AppendLine("<body>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<div id=\"wrapper\">");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<nav class=\"aussehen\"  >Head</nav>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<section class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<h2>Content</h2>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "more content");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</section>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<aside  class=\"aussehen\" >Footer</aside>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</div>");
                    sb.AppendLine();
                    sb.AppendLine("</body>");
                    sb.AppendLine();
                    sb.AppendLine("</html>");
                    break;
                case 5:
                    sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
                    sb.AppendLine("<!DOCTYPE html");
                    sb.AppendLine("  PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
                    sb.AppendLine("  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
                    sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
                    sb.AppendLine("<head>");
                    sb.AppendLine(Konst.C_TAB + "<title> Beispiel 1 </title>");
                    sb.AppendLine(Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
                    sb.AppendLine(Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
                    sb.AppendLine(Konst.C_TAB + "<link rel=\"stylesheet\"   type=\"text/css\"  href=\"" + cssfilename + "\" title=\"style1\"/>");
                    sb.AppendLine("</head>");
                    sb.AppendLine();
                    sb.AppendLine("<body>");
                    sb.AppendLine(Konst.C_TAB + "<div id=\"wrapper\">");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<header  class=\"aussehen\"  >Head</header>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<article class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<h2>Content</h2>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "more content");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</article>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<footer class=\"aussehen\" >Footer</footer>");
                    sb.AppendLine(Konst.C_TAB + "</div>");
                    sb.AppendLine();
                    sb.AppendLine("</body>");
                    sb.AppendLine();
                    sb.AppendLine("</html>");
                    break;
                case 6:
                    sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
                    sb.AppendLine("<!DOCTYPE html");
                    sb.AppendLine("  PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
                    sb.AppendLine("  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
                    sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
                    sb.AppendLine("<head>");
                    sb.AppendLine(Konst.C_TAB + "<title> Beispiel 1 </title>");
                    sb.AppendLine(Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
                    sb.AppendLine(Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />");
                    sb.AppendLine(Konst.C_TAB + "<link rel=\"stylesheet\"  type=\"text/css\"  href=\"" + cssfilename + "\" title=\"style1\"/>");
                    sb.AppendLine("</head>");
                    sb.AppendLine();
                    sb.AppendLine("<body>");
                    sb.AppendLine(Konst.C_TAB + "<div id=\"wrappercolumn\" >");
                    sb.AppendLine();
                    sb.AppendLine(Konst.C_TAB + "<header  class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Head");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"http://www.miwilhelm.de\" >    <em>Die Seite</em>  </a>  &#160; | &#160;&#160;  ");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"http://www.hs-harz.de/index.html\" target=\"_blank\">    HS-Harz   </a> &#160; | &#160;&#160;  ");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"http://www.bing.de\" target=\"_blank\">  Bing</a>");
                    sb.AppendLine(Konst.C_TAB + "</header>");
                    sb.AppendLine(Konst.C_TAB + "<div id=\"wrapperrow\" >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<nav class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "Navigator");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<ol>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"http://www.miwilhelm.de\" target=\"_blank\" >    <em>Die Seite</em>  </a></li>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"http://www.hs-harz.de/index.html\" target=\"_blank\">    HS-Harz   </a></li>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"http://www.google.de\" target=\"_blank\"> Google  </a></li>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</ol>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</nav>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<article class=\"aussehen\"  >");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<h2>Content</h2>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "more content");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</article>");
                    sb.AppendLine(Konst.C_TAB + "</div>");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<footer class=\"aussehen\" >Footer</footer>");
                    sb.AppendLine(Konst.C_TAB + "</div>");
                    sb.AppendLine();
                    sb.AppendLine("</body>");
                    sb.AppendLine();
                    sb.AppendLine("</html>");
                    break;
            }
            return sb.ToString();
        }




        public static void SaveCSS_Html_BasicXHTML(string sHTMLFilename, string sCSSFilename, int layout)   {

            string value = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\r\n" +
                   "<!DOCTYPE html\r\n" +
                   "     PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\r\n" +
                   "    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\r\n" +
                   "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\r\n" +
                   "<head>\r\n" +
                   "\t" + "<title> Beispiel 1 </title>\r\n" +
                   "\t" + "<meta name=\"author\" content=\"Administrator\"/>\r\n" +
                   "\t" + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n" +
                   "\t" + "<link rel=\"stylesheet\" type=\"text/css\"  href=\"" + Basis.getFilename(sCSSFilename) + "\" title=\"style1\"/>\r\n" +
                   "</head>\r\n" +
                   "\r\n" +
                   "<body>\r\n" +
                   "\t" + "<h3>Überschrift</h3>\r\n" +
                   "</body>\r\n" +
                   "</html>";

            string tabValue = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\r\n" +
                   "<!DOCTYPE html\r\n" +
                   "     PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\r\n" +
                   "    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\r\n" +
                   "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\r\n" +
                   "<head>\r\n" +
                   Konst.C_TAB + "<title> Beispiel 1 </title>\r\n" +
                   Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>\r\n" +
                   Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n" +
                   Konst.C_TAB + "<link rel=\"stylesheet\" type=\"text/css\"  href=\"" + Basis.getFilename(sCSSFilename) + "\" title=\"style1\"/>\r\n" +
                   "</head>\r\n" +
                   "\r\n" +
                   "<body>\r\n" +
                   Konst.C_TAB + "<h3>Überschrift</h3>\r\n" +
                   "</body>\r\n" +
                   "</html>";
            if (layout>0) {
                tabValue = getFlexLayoutHTML(layout, Basis.getFilename(sCSSFilename));
            }
            FileStream oFile = new FileStream(sHTMLFilename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(tabValue);
            oStream.Close();
            oFile.Close();

            writeCSSFile(sCSSFilename, layout);

        }

        public static void SavePHP_HTML(String filename, string sCSSFilename, int layout)  {
            string value = "<html>\r\n" +
                   "<head>\r\n" +
                   "\t" + "<title> PHP-Beispiel 1 </title>\r\n" +
                   "\t" + "<meta name=\"author\" content=\"Administrator\"/>\r\n" +
                   "\t" + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n" +
                   "\t" + "<link rel=\"stylesheet\" type=\"text/css\"  href=\"" + Basis.getFilename(sCSSFilename) + "\" title=\"style1\"/>\r\n" +
                   "</head>\r\n" +
                   "\r\n" +
                   "<!-- localhost:8080/bsp01.php -->\r\n" +
                   "\r\n" +
                   "<body>\r\n" +
                   "\t" + "<h3>Mein erstes PHP-Beispiel</h3>\r\n" +
                   "<?php\r\n" +
                    "\t" + "$ok = true;\r\n" +
                    "\t" + "$zahl = 0;\r\n" +
                    "\t" + "$errortext = '';\r\n" +
                    "\t" + "echo 'hallo Text';\r\n" +
                   "?>\r\n" +
                   "</body>\r\n" +
                   "</html>";

            string tavValue = "<html>\r\n" +
                   "<head>\r\n" +
                   Konst.C_TAB + "<title> PHP-Beispiel 1 </title>\r\n" +
                   Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>\r\n" +
                   Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n" +
                   Konst.C_TAB + "<link rel=\"stylesheet\" type=\"text/css\"  href=\"" + Basis.getFilename(sCSSFilename) + "\" title=\"style1\"/>\r\n" +
                   "</head>\r\n" +
                   "\r\n" +
                   "<!-- localhost:8080/bsp01.php -->\r\n" +
                   "\r\n" +
                   "<body>\r\n" +
                   Konst.C_TAB + "<h3>Mein erstes PHP-Beispiel</h3>\r\n" +
                   "<?php\r\n" +
                    Konst.C_TAB + "$ok = true;\r\n" +
                    Konst.C_TAB + "$zahl = 0;\r\n" +
                    Konst.C_TAB + "$errortext = '';\r\n" +
                    Konst.C_TAB + "echo 'hallo Text';\r\n" +
                   "?>\r\n" +
                   "</body>\r\n" +
                   "</html>";
            if (layout > 0) {
                value = getFlexLayoutHTML(layout, Basis.getFilename(sCSSFilename));
            }

            FileStream oFile = new FileStream(filename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(value);
            oStream.Close();
            oFile.Close();
            writeCSSFile(sCSSFilename, layout);
        }


        public static void SavePHPPUR(String filename) {
            string value = 
                   "<?php\r\n" +
                    "\t" + "$ok = true;\r\n" +
                    "\t" + "$zahl = 0;\r\n" +
                    "\t" + "$errortext = '';\r\n" +
                    "\t" + "echo 'hallo Text';\r\n" +
                   "?>\r\n" ;

            FileStream oFile = new FileStream(filename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(value);
            oStream.Close();
            oFile.Close();
        }

        public static void SaveJSP_HTML(String filename, string sCSSFilename, int layout)    {
            string value = "<html>\r\n" +
                   "<head>\r\n" +
                   Konst.C_TAB + "<title> 1. JSP-Beispiel </title>\r\n" +
                   Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>\r\n" +
                   Konst.C_TAB + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\r\n" +
                   Konst.C_TAB + "<link rel=\"stylesheet\" type=\"text/css\"  href=\"" + Basis.getFilename(sCSSFilename) + "\" title=\"style1\"/>\r\n" +
                   "</head>\r\n" +
                   "\r\n" +
                   "<!-- localhost:8080/jsp1.jsp -->\r\n" +
                   "\r\n" +
                   "<body>\r\n" +
                   Konst.C_TAB + "<h3>Mein erstes JSP-Beispiel</h3>\r\n" +
                   "\r\n" +
                   "\r\n" +
                   "</body>\r\n" +
                   "</html>";
            if (layout > 0) {
                value = getFlexLayoutHTML(layout, Basis.getFilename(sCSSFilename));
            }
            FileStream oFile = new FileStream(filename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(value);
            oStream.Close();
            oFile.Close();

            writeCSSFile(sCSSFilename, layout);
        }



        public static void SaveJSP_PUR(String filename, string sCSSFilename, int layout)     {
            string value = "\r\n" +
                   "<%!\r\n" +
                   "\t" + "Integer getIntNumber(String str_zahl) {\r\n" +
                   "\t" + "\t" + "try {\r\n" +
                   "\t" + "\t" + "\t" + "int zahl = Integer.parseInt(str_zahl);\r\n" +
                   "\t" + "\t" + "\t" + "return new Integer(zahl);\r\n" +
                   "\t" + "\t" + "}\r\n" +
                   "\t" + "\t" + "catch (NumberFormatException e) {\r\n" +
                   "\t" + "\t" + "\t" + "// return null;\r\n" +
                   "\t" + "\t" + "}\r\n" +
                   "\t" + "\t" + "return null;\r\n" +
                   "\t" + "}  // getIntNumber\r\n" +

                   "\r\n" +
                   "\r\n" +
                   "\t" + "double getDoubleNumber(String str_zahl) {\r\n" +
                   "\t" + "\t" + "try {\r\n" +
                   "\t" + "\t" + "\t" + "double zahl = Double.parseDouble(str_zahl);\r\n" +
                   "\t" + "\t" + "\t" + "return zahl;\r\n" +
                   "\t" + "\t" + "}\r\n" +
                   "\t" + "\t" + "catch (NumberFormatException e) {\r\n" +
                   "\t" + "\t" + "// return null;\r\n" +
                   "\t" + "\t" + "}\r\n" +
                   "\t" + "\t" + "return Double.NaN;\r\n" +
                   "\t" + "}  // getDoubleNumber\r\n" +
                   "%>\r\n" +
                   "\r\n" +
                   "\r\n" +
                   "\r\n" +


                   "<%\r\n" +
                   "\t" + "boolean ok=true;\r\n" +
                   "\t" + "String str_zahl = request.getParameter(\"zahl\");\r\n" +
                   "\t" + "out.println(\"Hier ist meine erste JSP-Datei <br />\");\r\n" +
                   " \r\n" +
                   "%>\r\n";

            string tabValue = "\r\n" +
                   "<%!\r\n" +
                   Konst.C_TAB + "Integer getIntNumber(String str_zahl) {\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "try {\r\n" +
                   Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "int zahl = Integer.parseInt(str_zahl);\r\n" +
                   Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return new Integer(zahl);\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "}\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "catch (NumberFormatException e) {\r\n" +
                   Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// return null;\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "}\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "return null;\r\n" +
                   Konst.C_TAB + "}  // getIntNumber\r\n" +

                   "\r\n" +
                   "\r\n" +
                   Konst.C_TAB + "double getDoubleNumber(String str_zahl) {\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "try {\r\n" +
                   Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "double zahl = Double.parseDouble(str_zahl);\r\n" +
                   Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return zahl;\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "}\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "catch (NumberFormatException e) {\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "// return null;\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "}\r\n" +
                   Konst.C_TAB + Konst.C_TAB + "return Double.NaN;\r\n" +
                   Konst.C_TAB + "}  // getDoubleNumber\r\n" +
                   "%>\r\n" +
                   "\r\n" +
                   "\r\n" +
                   "\r\n" +


                   "<%\r\n" +
                   Konst.C_TAB + "boolean ok=true;\r\n" +
                   Konst.C_TAB + "String str_zahl = request.getParameter(\"zahl\");\r\n" +
                   Konst.C_TAB + "out.println(\"Hier ist meine erste JSP-Datei <br />\");\r\n" +
                   " \r\n" +
                   "%>\r\n";
            if (layout > 0) {
                value = getFlexLayoutHTML(layout, Basis.getFilename(sCSSFilename));
            }
            FileStream oFile = new FileStream(filename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(value);
            oStream.Close();
            oFile.Close();

            writeCSSFile(sCSSFilename, layout);
        }


        


        public static void SaveJAVASCRIPT(String filename) {
            string value = "\r\n" +
                   "    // <![CDATA[\r\n\r\n" +
                   "     function calc(form) {\r\n"+
                   "       \"use strict\";\r\n"+
                   "       alert(\"here in f\");\r\n"+
                   "     }\r\n\r\n"+
                   "    // ]]>\r\n\r\n";
            FileStream oFile = new FileStream(filename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(value);
            oStream.Close();
            oFile.Close();

        }  // SaveJAVASCRIPT

        public static void SaveCSS_Html_HTML5(string sHTMLFilename, string sCSSFilename, int layout) {

            string value = "<!DOCTYPE html>\r\n" +
                   "<html xmlns=\"http://www.w3.org/1999/xhtml\" >\r\n" +
                   "\t<head>\r\n" +
                   "\t\t<title> Beispiel 1 </title>\r\n" +
                   "\t\t\t<meta name=\"author\" content=\"Administrator\"/>\r\n" +
                   "\t\t\t<meta charset=\"UTF-8\" />\r\n" +
                   "\t\t\t<link rel=\"stylesheet\" type=\"text/css\"\r\n" +
                   "\t\t\t\thref=\"" + Basis.getFilename(sCSSFilename) + "\" title=\"style1\"/>\r\n" +
                   "\t</head>\r\n" +
                   "\r\n" +
                   "<body>\r\n" +
                   "\t<h1>\r\n" +
                   "\t\tÜberschrift\r\n" +
                   "\t</h1>\r\n" +
                   "\t<section>\r\n" +
                   "\t    <header>\r\n" +
                   "\tDiese section beschreibt vollständig HTML5\r\n" +
                   "\t    </header>\r\n" +
                   "\t\r\n" +
                   "\t    <footer>\r\n" +
                   "\t\tfooter\r\n" +
                   "\t    </footer>\r\n" +
                   "\t  </section>\r\n" +
                   "</body>\r\n" +
                   "</html>";
            if (layout > 0) {
                value = getFlexLayoutHTML(layout, Basis.getFilename(sCSSFilename));
            }
            FileStream oFile = new FileStream(sHTMLFilename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(value);
            oStream.Close();
            oFile.Close();

            SaveCSSHTML5(sCSSFilename, layout);
        }

        // GridGrid
        private static String getFlexLayoutCSS(int layout)   {
            StringBuilder sb = new StringBuilder();
            switch (layout) {
                case 1:  // Grid horizontal
                    sb.AppendLine(Konst.C_TAB + "#wrapper {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "display: grid;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-columns: 10rem auto 10rem;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-rows: auto;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column-gap: 5px;  /* nur zwischen den Elementen oder bei den Bereichen mit margin */");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row-gap: 5px;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color:yellow;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + ".aussehen {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "margin: 5px;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border: 2px ridge #C5D8E1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border-radius: 10px;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "header {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: deepskyblue;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "section {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: orange;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 2;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "min-height: 150px;  /* EINE Höhe reicht aus !!!  */");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "aside {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: limegreen;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 3;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
                    sb.AppendLine(Konst.C_TAB + "}"); break;

                case 2:  // Grid  vertikal
                    sb.AppendLine(Konst.C_TAB + "#wrapper {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "display: grid;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-columns: auto;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-rows: 3rem auto 3rem;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column-gap: 5px;  /* nur zwischen den Elementen oder bei den Bereichen mit margin */");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row-gap: 5px;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color:yellow;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + ".aussehen {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "margin: 5px;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border: 2px ridge #C5D8E1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border-radius: 10px;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "header {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: deepskyblue;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "article {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: orange;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 2;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "min-height: 150px;  /* EINE Höhe reicht aus !!!  */");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "footer {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: limegreen;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 3;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    break;

                case 3:  // Grid normal
                    sb.AppendLine(Konst.C_TAB + "#wrapper {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "display: grid;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-columns: 12rem auto;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-rows: 3rem auto 3rem;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column-gap: 5px;  /* nur zwischen den Elementen oder bei den Bereichen mit margin */");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row-gap: 5px;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color:yellow;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + ".aussehen {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "margin: 5px;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border: 2px ridge #C5D8E1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border-radius: 10px;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "header {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: deepskyblue;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1 / span 2;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "nav {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: deepskyblue;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 2;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "min-height: 150px;  /* EINE Höhe reicht aus !!!  */");
                    sb.AppendLine(Konst.C_TAB + "}");
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "article {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: orange;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 2;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 2;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "min-height: 150px;  /* EINE Höhe reicht aus !!!  */");
                    sb.AppendLine(Konst.C_TAB + "}"); 
                    sb.AppendLine("");
                    sb.AppendLine(Konst.C_TAB + "footer {");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: limegreen;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1  / span 2;");
                    sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 3;");
                    sb.AppendLine(Konst.C_TAB + "}");
                    break;

                case 4:  // horizontal
                    sb.AppendLine("#wrapper {");
                    sb.AppendLine("display: flex;");
                    sb.AppendLine("  flex-direction: row;  /* row column  */");
                    sb.AppendLine("  background-color:yellow;");
                    sb.AppendLine("  align-items: stretch;");
                    sb.AppendLine("  aalign-items: flex-end;");
                    sb.AppendLine("  aalign-items: flex-start;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine(".aussehen {");
                    sb.AppendLine("  margin: 5px;");
                    sb.AppendLine("  border: 2px ridge #C5D8E1;");
                    sb.AppendLine("  border-radius: 10px;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("nav{");
                    sb.AppendLine("  background-color: deepskyblue;");
                    sb.AppendLine("  flex-basis: 20%;");
                    sb.AppendLine("  fflex-grow: 1;");
                    sb.AppendLine();
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("section {");
                    sb.AppendLine("  background-color: orange;");
                    sb.AppendLine("  fflex: 1;");
                    sb.AppendLine("  flex-basis: 60%;");
                    sb.AppendLine("  min-height: 150px;  /* EINE Höhe reicht aus !!!  */");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("aside {");
                    sb.AppendLine("  background-color: limegreen;");
                    sb.AppendLine("  flex-basis: 20%;");
                    sb.AppendLine("}");

            break;
                case 5:
                    sb.AppendLine("#wrapper {");
                    sb.AppendLine("display: flex;");
                    sb.AppendLine("  flex-direction: column;");
                    sb.AppendLine("  height: 200px;  /* height  procentual ist not good, scrolling */");
                    sb.AppendLine("  width: 90%;");
                    sb.AppendLine("  min-height: 150px;");
                    sb.AppendLine("  background-color:yellow;");
                    sb.AppendLine("  align-items: stretch;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine(".aussehen {");
                    sb.AppendLine("  margin: 5px;");
                    sb.AppendLine("  border: 2px ridge #C5D8E1;");
                    sb.AppendLine("  border-radius: 10px;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("header {");
                    sb.AppendLine("  background-color: deepskyblue;");
                    sb.AppendLine("  height: 1.2em;");
                    sb.AppendLine("  fflex: 1;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("article {");
                    sb.AppendLine("  background-color: orange;");
                    sb.AppendLine("  flex: 2;");
                    sb.AppendLine("  fflex-basis: 20%;");
                    sb.AppendLine("   min-height: 150px;  /* EINE Höhe reicht aus !!!  */");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("footer {");
                    sb.AppendLine("  background-color: limegreen;");
                    sb.AppendLine("  height: 1.2em;");
                    sb.AppendLine("}");
            break;
                case 6:

                    sb.AppendLine("#wrappercolumn {");
                    sb.AppendLine("  display: flex;");
                    sb.AppendLine("  flex-direction: column;");
                    sb.AppendLine("  hheight:400px;  /* hoehe in prozent ist schwachsinnig, da man scrollen kann */");
                    sb.AppendLine("  width:100%; ");
                    sb.AppendLine("  mmin-height: 250px;");
                    sb.AppendLine("  background-color:yellow; ");
                    sb.AppendLine("  align-items: stretch;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine();
                    sb.AppendLine("#wrapperrow {");
                    sb.AppendLine("  display:flex;");
                    sb.AppendLine("  flex-direction: row;  /* row column  */");
                    sb.AppendLine("  background-color:red; ");
                    sb.AppendLine("  align-items: stretch;");
                    sb.AppendLine("  aalign-items: flex-end;");
                    sb.AppendLine("  aalign-items: flex-start;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine();
                    sb.AppendLine(".aussehen {");
                    sb.AppendLine("  margin:5px;");
                    sb.AppendLine("  border: 2px ridge #C5D8E1;");
                    sb.AppendLine("  border-radius: 10px;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine();
                    sb.AppendLine("header { ");
                    sb.AppendLine("   background-color: deepskyblue; ");
                    sb.AppendLine("   height:1.2em;");
                    sb.AppendLine("   fflex: 1; ");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine();
                    sb.AppendLine("nav{ ");
                    sb.AppendLine("   background-color: deepskyblue; ");
                    sb.AppendLine("   fflex-basis: 20%;");
                    sb.AppendLine("   fflex-grow: 1;");
                    sb.AppendLine("   width:12em;");
                    sb.AppendLine("}");
                    sb.AppendLine("nav ol{");
                    sb.AppendLine("    /* the list in nav without points */ ");
                    sb.AppendLine("  list-style-type:none;");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("article { ");
                    sb.AppendLine("  background-color: orange;");
                    sb.AppendLine("  flex: 1; ");
                    sb.AppendLine("  fflex-basis: 20%;");
                    sb.AppendLine("  min-height: 150px;  /* EINE Höhe reicht aus !!  */");
                    sb.AppendLine("}");
                    sb.AppendLine();
                    sb.AppendLine("footer { ");
                    sb.AppendLine("  background-color: limegreen; ");
                    sb.AppendLine("  height:1.2em;");
                    sb.AppendLine("}");
                    break;
            }
            return sb.ToString();
        }



        private static void writeCSSFile(String cssFilename, int layout)
        {
            //String value = "body {\r\n" +
            //        "  font-size: 1.2em;\r\n" +
            //        "  color: black;\r\n" +
            //        "  font-family: Verdana, Arial, Helvetica, sans-serif;\r\n" +
            //        "  font-weight: 400;\r\n" +
            //        "}\r\n";

            StringBuilder sb = new StringBuilder();
            sb.AppendLine("body {");
            //sb.AppendLine(Konst.C_TAB+"font-size: 1.2em;");
            sb.AppendLine(Konst.C_TAB + "color: rgb(2,2,2);");
            sb.AppendLine(Konst.C_TAB + "background-color:#FAFAFA;");
            sb.AppendLine(Konst.C_TAB + "font-family: 'Fira Sans', Verdana, sans-serif, Arial, Helvetica;");
            sb.AppendLine(Konst.C_TAB + "line-height: 1.6;");
            sb.AppendLine(Konst.C_TAB + "max-width: 40rem;");  // 640 Pixel
            sb.AppendLine(Konst.C_TAB + "padding:2rem;");
            sb.AppendLine(Konst.C_TAB + "margin:auto;");
            //sb.AppendLine(Konst.C_TAB + "font-weight: 400;");
            sb.AppendLine("}");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("img {");
            sb.AppendLine(Konst.C_TAB + "max-width: 100 %;");
            sb.AppendLine("}");

            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("a {");
            sb.AppendLine(Konst.C_TAB + "color:#FF4444;");
            sb.AppendLine("}");

            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("h1,h2, strong {");
            sb.AppendLine(Konst.C_TAB + "color:#010101;");
            sb.AppendLine("}");

            FileStream oFile = new FileStream(cssFilename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(sb.ToString()); //  value);
            if (layout > 0) {
                oStream.WriteLine(getFlexLayoutCSS(layout));
            }

            oStream.Close();
            oFile.Close();
        }

        public static void SaveCSSHTML5(String filename, int layout) {
            StringBuilder sb = new StringBuilder();
            //sb.AppendLine("body {\r\n" +
            //    "\tfont-size: 1.1em;\r\n" +
            //    "\tcolor: rgb(100,100,100);\r\n" +
            //    "\tfont-family: Arial, Helvetica, Verdana, sans-serif;\r\n" +
            //    "\tfont-weight: 400;\r\n" +
            //    "}\r\n");
            
            sb.AppendLine("body {");
            //sb.AppendLine(Konst.C_TAB+"font-size: 1.2em;");
            sb.AppendLine(Konst.C_TAB + "color: rgb(2,2,2);");
            sb.AppendLine(Konst.C_TAB + "background-color:#FAFAFA;");
            sb.AppendLine(Konst.C_TAB + "font-family: 'Fira Sans', Verdana, sans-serif, Arial, Helvetica;");
            sb.AppendLine(Konst.C_TAB + "line-height: 1.6;");
            sb.AppendLine(Konst.C_TAB + "max-width: 40rem;");  // 640 Pixel
            sb.AppendLine(Konst.C_TAB + "padding:2rem;");
            sb.AppendLine(Konst.C_TAB + "margin:auto;");
            //sb.AppendLine(Konst.C_TAB + "font-weight: 400;");
            sb.AppendLine("}");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("img {");
            sb.AppendLine(Konst.C_TAB + "max-width: 100 %;");
            sb.AppendLine("}");

            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("a {");
            sb.AppendLine(Konst.C_TAB + "color:#FF4444;");
            sb.AppendLine("}");

            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("h1,h2, strong {");
            sb.AppendLine(Konst.C_TAB + "color:#010101;");
            sb.AppendLine("}");
            sb.AppendLine();
            sb.AppendLine();

            sb.AppendLine("section {\r\n" +
                "\tfont-size: 1.2em;\r\n" +
                "\tcolor: rgb(255,0,0);\r\n" +
                "\tfont-family: Arial, Helvetica, Verdana, sans-serif;\r\n" +
                "\tfont-weight: 400;\r\n" +
                "}\r\n");
            sb.AppendLine();
            sb.AppendLine("article {\r\n" +
                "\tfont-size: 1.1em;\r\n" +
                "\tcolor: rgb(0,0,255);\r\n" +
                "\tfont-family: Arial, Helvetica, Verdana, sans-serif;\r\n" +
                "\tfont-weight: 400;\r\n" +
                "}\r\n");
            sb.AppendLine();
            sb.AppendLine("footer {\r\n" +
                "\tfont-size: 0.9em;\r\n" +
                "\tcolor: rgb(0,0,255);\r\n" +
                "\tfont-family: Arial, Helvetica, Verdana, sans-serif;\r\n" +
                "\tfont-weight: 400;\r\n" +
                "}\r\n");

            FileStream oFile = new FileStream(filename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);
            oStream.WriteLine(sb.ToString());
            if (layout > 0) {
                oStream.WriteLine(getFlexLayoutCSS(layout));
            }
            oStream.Close();
            oFile.Close();
        }


    }
}
